unit Oradoc_lib;

interface

uses TFlatListBoxUnit, TFlatButtonUnit, TFlatTabControlUnit, grids, db,
     Registry, sysutils, Windows, forms, stdctrls, TFlatMemoUnit, Graphics;

const PANEL_TEXT_RATE = 10;

      MAIN_FORM_HEIGHT = 513;
      MAIN_FORM_WIDTH = 610;
      TAB_PANEL_HEIGHT = 432;
      TAB_PANEL_WIDTH = 606;
      TAB_CLIENTPANEL_HEIGHT = 369;
      TAB_CLIENTPANEL_WIDTH = 576;

      OPTIONS_FORM_HEIGHT = 470;
      OPTIONS_FORM_WIDTH = 529;
      OPTIONS_CLIENTPANEL_HEIGHT = 378;
      OPTIONS_CLIENTPANEL_WIDTH = 505;

      FIRSTVERSIONNUMBER = '1.0';
      MAINFORMCAPTION = 'Oracle Database Documentation ';
      FILESUFFIX = '.odd';
      PROJECTHISTORYFILESUFFIX = '.prh';
      //DBHISTORYFILESUFFIX = '.DBH';
      TXTFILESUFFIX = '.txt';
      HTMLFILESUFFIX = '.htm';
      SAVEASTEXT = 'Save as';
      SBMODIFIEDTEXT = 'Modified';
      SBNOTCONNECTEDTEXT = 'Not connected';
      SAVECHANGES = 'Save changes?';
      EMPTYHISTORY = '&Empty history';
      AT = '@';
      HYPHEN = '-';
      BACKSLASH = '\';
      CREATEERROR = 'ERROR: Oracle Database Documentation Project file %s can''t be created.';
      OPENERROR = 'ERROR: Oracle Database Documentation Project file %s can''t be opened.';
      EMPTY = '';
      EMPTYSPACE = ' ';
      FILTERTEXTODD = 'Oracle Database Document Project (*.odd) | *.odd';
      FILTERTEXTDBH = 'Oracle Database Document Project (*.dbh) | *.dbh';
      FILTERTEXTPRH = 'Oracle Database Document Project (*.prh) | *.prh';
      FILTERBUILD = 'Oracle Database Document (*.htm)|*.htm|Oracle Database Document (*.txt)|*.txt';
      BUILDPROJECTTEXT = 'Building Oracle Database Document';
      NEWPROJECTTEXT = 'New Project';
      OPENPROJECTTEXT = 'Open Project';
      CHOOSEPROJECTHISTORY = 'Choose Project History File';
      CHOOSEPROJECTDIR = 'Choose Project Directory';
      CHOOSEDBHISTORY = 'Choose Database Log History File';

      REGISTRYPATH = 'Software\ODD\';
      REGISTRYKEY = 'Options';
      FUNCTION_OPENTAG = 'Function_opentag';
      DEF_FUNCTION_OPENTAG = '<FD>';
      FUNCTION_DESCRIPTION = 'Function_description';
      DEF_FUNCTION_DESCRIPTION = 'Description';
      FUNCTION_PARAMETERS = 'Function_parameters';
      DEF_FUNCTION_PARAMETERS = 'Parameters';
      FUCNTION_SPOT = 'Function_spot';
      DEF_FUCNTION_SPOT = ',';
      FUNCTION_COLON = 'Function_colon';
      DEF_FUNCTION_COLON = ':';
      FUNCTION_SEMICOLON = 'Function_semicolon';
      DEF_FUNCTION_SEMICOLON = ';';
      FUNCTION_RETURNVALUE = 'Function_returnvalue';
      DEF_FUNCTION_RETURNVALUE ='Return value';
      FUNCTION_CLOSETAG = 'Function_closetag';
      DEF_FUNCTION_CLOSETAG = '</FD>';

      PACKAGE_OPENTAG = 'Package_opentag';
      DEF_PACKAGE_OPENTAG = '<PD>';
      PACKAGE_DESCRIPTION = 'Package_description';
      DEF_PACKAGE_DESCRIPTION = 'Description';
      PACKAGE_CLOSETAG = 'Package_closetag';
      DEF_PACKAGE_CLOSETAG = '</PD>';

      PACKAGE_FUNCTION_OPENTAG = 'Package_function_opentag';
      DEF_PACKAGE_FUNCTION_OPENTAG = '<FD>';
      PACKAGE_FUNCTION = 'Package_function';
      DEF_PACKAGE_FUNCTION = 'Function';
      PACKAGE_PROCEDURE = 'Package_procedure';
      DEF_PACKAGE_PROCEDURE = 'Procedure';
      PACKAGE_FUNCTION_DESCRIPTION = 'Package_function_description';
      DEF_PACKAGE_FUNCTION_DESCRIPTION = 'Description';
      PACKAGE_FUNCTION_PARAMETERS = 'Package_function_parameters';
      DEF_PACKAGE_FUNCTION_PARAMETERS = 'Parameters';
      PACKAGE_FUCNTION_SPOT = 'Package_function_spot';
      DEF_PACKAGE_FUCNTION_SPOT = ',';
      PACKAGE_FUNCTION_COLON = 'Package_function_colon';
      DEF_PACKAGE_FUNCTION_COLON = ':';
      PACKAGE_FUNCTION_SEMICOLON = 'Package_function_semicolon';
      DEF_PACKAGE_FUNCTION_SEMICOLON = ';';
      PACKAGE_FUNCTION_RETURNVALUE = 'Package_function_returnvalue';
      DEF_PACKAGE_FUNCTION_RETURNVALUE = 'Return value';
      PACKAGE_FUNCTION_CLOSETAG = 'Package_function_closetag';
      DEF_PACKAGE_FUNCTION_CLOSETAG = '</FD>';

      DOCUMENTPARTS = 'Document_parts';
      DEF_DOCUMENTPARTS = 'TTTTTTTT';
      TRUEVALUE = 'T';
      DOCPARTCOUNT = 8;

      HISTORYFILE = 'History_file';
      PROJECTDIR = 'Project_dir';
      DBLOGHISTORY = 'DBLog_history';
      DEF_DBLOGHISTORY = 'Oradoc.dbh';
      DEF_HISTORYFILE = 'Oradoc.prh';

      DBLOGPREVIOUS = '[PREVIOUS]';
      DBLOGLAST = '[LAST]';
      DBLOGCREATEERROR = 'ERROR: Database log file %s can''t be created.';
      DBLOGOPENERROR = 'ERROR: Database log file %s can''t be opened.';
      LOGINERROR = 'ERROR: ';
      NODATABASE = 'Enter database before login.';
      NOPASSWORD = 'Enter password before login.';
      NOUSER = 'Enter user before login.';

      DIRNOTFOUNDERROR = 'ERROR: Directory %s not found.';
      FILENOTFOUNDERROR = 'ERROR: File %s not found.';
      DOCUMENTCREATEERROR = 'ERROR: Can''t create a file %s.';

      HTMLTAB = '&nbsp;&nbsp;&nbsp;&nbsp;';

type TAppState = (asProjectNotOpened, asProjectOpened);

//var tags : array [1..4] of string;

procedure ListAdd(FirstList, SecondList: TFlatListbox; SGrid: TStringgrid;
    BTAdd, BTAddAll, BTRemove, BTRemoveAll: TFlatButton; FlatTabControl: TFlatTabControl);
procedure ListAddAll(FirstList, SecondList: TFlatListbox;
    SGrid: TStringgrid; BTAdd, BTAddAll, BTRemove, BTRemoveAll: TFlatButton;
    FlatTabControl: TFlatTabControl);
procedure MoveToGrid(SGrid: TStringgrid; List: TFlatListBox; iItemIndex: Integer;
    FlatTabControl: TFlatTabControl);
procedure MoveToList(SourceList, DestinationList: TFlatListBox; iItemIndex: integer);
procedure RemoveFromList(List: TFlatListBox; iItemIndex: integer);
function ReadValuefromRegistry(szPath: String; szKey: String;
    szValue: String; bCreate: boolean = FALSE; hElementalKey: HKEY = HKEY_LOCAL_MACHINE): String;
procedure WriteValuetoRegistry(szPath: String; szKey: String;
    szValue: String; szVal: String; hElementalKey: HKEY = HKEY_LOCAL_MACHINE);
procedure EmptyGrid(SGrid: TStringgrid);
procedure LoadGrid(SGrid: TStringgrid; FirstList, SecondList: TFlatListBox;
    var tfFile: TextFile; iRowCount: Integer);
procedure RemoveFromGrid(SGrid: TStringgrid; List :TFlatListBox; iItemIndex: Integer);
procedure RemoveRow(SGrid: TStringGrid; iRow: Integer);
function GetFileInfo(szFileName:string; var szCreatedDate: String;
    var szUpdatedDate: String; var szCreatedTime: String;
    var szUpdatedTime: String; var fSize: double): Boolean;
procedure SaveGrid(SGrid: TStringGrid; var tfFile: TextFile);
procedure FillList(SGrid: TStringgrid; List: TFlatListBox;
    DS: TDataSet; szField: String);
procedure setButtons(SourceList, DestList: TFlatListBox;
    btnAdd, btAddAll, btnRemove, btnRemoveAll: TFlatButton);
procedure ListRemove(FirstList, SecondList: TFlatListbox;
    SGrid: TStringgrid; BTAdd, BTAddAll, BTRemove, BTRemoveAll: TFlatButton;
    Memo: TFlatMemo);
procedure ListRemoveAll(FirstList, SecondList: TFlatListbox;
    SGrid: TStringgrid; BTAdd, BTAddAll, BTRemove, BTRemoveAll: TFlatButton;
    Memo: TFlatMemo);
procedure AddToGrid(SGrid: TStringgrid; szText: String; iColumn: Integer);
procedure AppendToGrid(SGrid: TStringgrid; szText: String; iColumn: Integer);
procedure FromGridToMemo(SGrid: TStringgrid; Memo: TMemo;
    CellWidths: array of Integer; BHeader: Boolean; BHtml: Boolean);
function TrimText(szText: String; iSize: Integer): String;
procedure setMemoField(MemoField: TFlatMemo; BEnabled: Boolean);
function SelectedIndex(List: TFlatListBox): Integer;
procedure setFormPosition(Form: TForm; iLeft, iTop, iWidth, iHeight: Integer);

implementation

uses Oradoc_datamodule, Oradoc_options_packagetags, Oradoc_main;

procedure ListRemove(FirstList, SecondList: TFlatListbox;
    SGrid: TStringgrid; BTAdd, BTAddAll, BTRemove, BTRemoveAll: TFlatButton;
    Memo: TFlatMemo);
var iI,iJ: Integer;
    BIsIt: Boolean;
    iArray: array of Integer;
begin
    BIsIt := false;
    iJ := 0;
    { Check if there is any selection made }
    for iI := 0 to SecondList.Items.Count -1  do
        if SecondList.Selected[iI] then
            begin
            BIsIt := true;
            setLength(iArray,length(iArray)+1);
            iArray[length(iArray)-1] := iI - iJ;
            inc(iJ);
            end;

    if BIsIt then
    begin
        for iI := 0 to length(iArray) - 1 do
           begin
               RemoveFromGrid(SGrid, FirstList, iArray[iI]);
               RemoveFromList(SecondList, iArray[iI]);
           end;
    FRMMAIN.setModifiedText(Oradoc_lib.SBMODIFIEDTEXT);
    if (SecondList.Items.count = 0) and (Memo <> nil) then
        setMemoField(Memo, false);

    setButtons(FirstList, SecondList, BTAdd, BTAddAll, BTRemove, BTRemoveAll);
    end;
end;

procedure ListRemoveAll(FirstList, SecondList: TFlatListbox;
    SGrid: TStringgrid; BTAdd, BTAddAll, BTRemove, BTRemoveAll: TFlatButton;
    Memo: TFlatMemo);
begin
    while SecondList.items.count <> 0 do
    begin
        RemoveFromGrid(SGrid, FirstList, 0);
        RemoveFromList(SecondList, 0)
    end;
    FRMMAIN.setModifiedText(Oradoc_lib.SBMODIFIEDTEXT);
    if Memo <> nil then
        setMemoField(Memo, false);
    setButtons(FirstList, SecondList, BTAdd, BTAddAll, BTRemove, BTRemoveAll);
end;


procedure ListAddAll(FirstList, SecondList: TFlatListbox;
    SGrid: TStringgrid; BTAdd, BTAddAll, BTRemove, BTRemoveAll: TFlatButton;
    FlatTabControl: TFlatTabControl);
begin
    while FirstList.items.count <> 0 do
        begin
        MoveToGrid(SGrid, FirstList, 0, FlatTabControl);
        MoveToList(FirstList, SecondList, 0);
        RemoveFromList(FirstList, 0)
        end;
    FRMMAIN.setModifiedText(Oradoc_lib.SBMODIFIEDTEXT);
    setButtons(FirstList, SecondList, BTAdd, BTAddAll, BTRemove, BTRemoveAll);
end;

procedure ListAdd(FirstList, SecondList: TFlatListbox; SGrid: TStringgrid;
    BTAdd, BTAddAll, BTRemove, BTRemoveAll: TFlatButton; FlatTabControl: TFlatTabControl);
var iI,iJ: Integer;
    BIsIt: Boolean;
    iArray: array of Integer;
begin
    BIsIt := false;
    iJ := 0;
    { Check if there is any selection made }
    for iI := 0 to FirstList.Items.Count - 1 do
        if FirstList.Selected[iI] then
            begin
            BIsIt := true;
            setLength(iArray,length(iArray)+1);
            iArray[length(iArray)-1] := iI - iJ;
            inc(iJ);
            end;

    if BIsIt then
    begin
        for iI := 0 to length(iArray) - 1 do
           begin
               MoveToGrid(SGrid, FirstList, iArray[iI], FlatTabControl);
               MoveToList(FirstList, SecondList, iArray[iI]);
               RemoveFromList(FirstList, iArray[iI])
           end;
    FRMMAIN.setModifiedText(Oradoc_lib.SBMODIFIEDTEXT);
    end;
    setButtons(FirstList, SecondList, BTAdd, BTAddAll, BTRemove, BTRemoveAll);
end;



procedure MoveToGrid(SGrid: TStringgrid; List: TFlatListBox; iItemIndex: Integer;
    FlatTabControl: TFlatTabControl);
var bInside, bNoTag, BDescriptionFound: boolean;
    szText, szRow: string;
begin
    SGrid.RowCount := SGrid.RowCount + 1;
    SGrid.Cells[0,SGrid.rowcount-1] := DMODD.OCIDatabase.ServerName;
    SGrid.Cells[1,SGrid.rowcount-1] := List.Items.Strings[iItemIndex];
    SGrid.Cells[2,SGrid.rowcount-1] := DMODD.OCIDatabase.UserName;
    SGrid.Cells[3,SGrid.rowcount-1] := DMODD.OCIDatabase.Password;
    case FlatTabControl.ActiveTab of
    { Table comments }
    1: with DMODD.OCIComments do
       begin
           close;
           Params[0].ParamType := ptInput;
           Params[0].DataType := ftString;
           Params[0].AsString := List.Items.Strings[iItemIndex];
           open;

           SGrid.Cells[4,SGrid.rowcount-1] := fieldbyname('COMMENTS').asString;
        end;
    // Pakettien kommentit
    4: with DMODD.OCIPackageText do
       begin
           close;
           Params[0].ParamType := ptInput;
           Params[0].DataType := ftString;
           Params[0].AsString := List.Items.Strings[iItemIndex];
           open;

           first;
           bInside := false;
           bNoTag := false;
           BDescriptionFound := false;
           szText := '';
           while (not bNoTag) and (not eof) do
               begin
               szRow := fieldbyname('TEXT').asString;
               if pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdPackageClose.text),
                   Ansiuppercase(szRow)) <> 0  then
                   begin
                   bNoTag := true;
                   bInside := false;
                   end;

               if bInside then
                  begin
                      if BDescriptionFound then
                          szText := szText +' '+trim(szRow)
                      else
                      if pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdDescription1.text),Ansiuppercase(szRow)) <> 0 then
                          BDescriptionFound := true;
                  end;

               if (pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdPackageOpen.text),
                   Ansiuppercase(szRow)) <> 0) and (not bInside)
                   then bInside := true;

               next;
               end;

           SGrid.Cells[4,SGrid.rowcount-1] := trim(szText);
        end;
    end;
end;

procedure MoveToList(SourceList, DestinationList: TFlatListBox; iItemIndex: integer);
begin
    DestinationList.Items.Add(ansiuppercase(DMODD.OCIDatabase.ServerName)+'.'+
        SourceList.Items.Strings[iItemIndex])
end;

procedure RemoveFromList(List: TFlatListBox; iItemIndex: integer);
begin
    List.Items.Delete(iItemIndex);
end;

{==============================================================================
 function ReadValuefromRegistry

 Author:
     Jussi Someristo

 Date:
     4.11.1999

 Description:
     Function reads String value from registry.

 Parameters:
     szPath, String: Registry path.
     szKey, String: Registry key.
     szValue, String: Registry key value.
     bCreate, boolean: Specifies whether to create the specified key if it does
         not exist. If CanCreate is True, the key is created if necessary.
     hElementalKey, hkey: Specifies the root key for the TRegistry object in an
         application.
         Possible alternatives are:
             HKEY_LOCAL_MACHINE (default)
             HKEY_CURRENT_USER
             HKEY_USERS
             HKEY_CURRENT_CONFIG
             HKEY_CLASSES_ROOT

 Result (String):
     Retrieves a String value from a specified data value associated with the
     current key.

 Modifications:
 ==============================================================================}
function ReadValuefromRegistry(szPath: String; szKey: String; szValue: String;
    bCreate: boolean = FALSE; hElementalKey: HKEY = HKEY_LOCAL_MACHINE): String;
var reg : TRegistry;
begin
    reg := TRegistry.Create;
    with reg do
        try
            try
                RootKey := hElementalKey;
                OpenKey(szPath + szKey, bCreate);
                result := ReadString(szValue);
            except
                result := '';
            end;
        finally
            reg.Free;
        end;
end;

{==============================================================================
 function ReadValuefromRegistry

 Author:
     Jussi Someristo

 Date:
     4.11.1999

 Description:
     Function writes String value to registry.

 Parameters:
     szPath, String: Registry path.
     szKey, String: Registry key.
     szValue, String: Registry key value.
     hElementalKey, hkey: Specifies the root key for the TRegistry object in an
         application.
         Possible alternatives are:
             HKEY_LOCAL_MACHINE (default)
             HKEY_CURRENT_USER
             HKEY_USERS
             HKEY_CURRENT_CONFIG
             HKEY_CLASSES_ROOT

 Modifications:
 ==============================================================================}
procedure WriteValuetoRegistry(szPath: String; szKey: String; szValue: String;
    szVal: String; hElementalKey: HKEY = HKEY_LOCAL_MACHINE);
var reg: TRegistry;
begin
    reg := TRegistry.Create;
    with reg do
        try
            RootKey := hElementalKey;
            OpenKey(szPath + szKey, True);
            WriteString(szValue, szVal);
        finally
            reg.Free;
        end;
end;

procedure EmptyGrid(SGrid: TStringgrid);
var iI, iJ: Integer;
begin
    for iI:= 0 to SGrid.ColCount - 1 do
        for iJ := 0 to SGrid.RowCount - 1 do
            SGrid.Cells[iI,iJ] := '';
    SGrid.RowCount := 1;
    SGrid.ColCount := 1;
end;

procedure RemoveRow(SGrid: TStringGrid; iRow: Integer);
var iRowCount, iI, iJ: Integer;
begin
    iRowCount := SGrid.RowCount;
    { Koska StringGrid- kontrollista voi poistaa rivej
      vain lopusta, niin siirretn poistettavan rivin
      jlkeiset rivit yht rivi ylspin, ja poistetaan
      lopuksi viimeinen rivi. Jos rivej on jljell vain
      yksi (+ otsikkorivi), niin viimeinen rivi vain
      tyhjennetn, ei poisteta. }

    for iI := iRow to iRowCount - 1 do
        for iJ := 0 to SGrid.ColCount do
            SGrid.Cells[iJ, iI] := SGrid.Cells[iJ, iI + 1];
    if iRowCount > 1 then
        SGrid.RowCount := iRowCount - 1
    else
        for iJ := 0 to SGrid.ColCount do
            SGrid.Cells[iJ, 1] := '';
end;

procedure RemoveFromGrid(SGrid: TStringgrid; List :TFlatListBox; iItemIndex: Integer);
begin
    if (SGrid.Cells[0, iItemIndex+1] = DMODD.OCIDatabase.ServerName) and
       (SGrid.Cells[2, iItemIndex+1] = DMODD.OCIDatabase.UserName) and
       (SGrid.Cells[3, iItemIndex+1] = DMODD.OCIDatabase.Password) then
        List.Items.Add(SGrid.cells[1, iItemIndex+1]);
    RemoveRow(SGrid, iItemIndex+1)
end;

procedure LoadGrid(SGrid: TStringgrid; FirstList, SecondList: TFlatListBox;
    var tfFile: TextFile; iRowCount: Integer);
var iI, iJ, iColumn: Integer;
    szText: String;
begin
    iJ := 1;

    while SecondList.items.count <> 0 do
    begin
        RemoveFromGrid(SGrid, FirstList, 1);
        RemoveFromList(SecondList, 0)
    end;
    FirstList.Items.Clear;
    SecondList.items.clear;
    for iI := 1 to iRowCount do
    begin
        readln(tfFile, szText);
        FRMMAIN.DeScramble(szText, iJ);
        inc(iJ);
        if iJ > 3 then
            iJ := 1;
        iColumn := 0;
        SGrid.RowCount := SGrid.RowCount + 1;
        while szText <> '' do
        begin
            SGrid.Cells[iColumn, iI] := copy(szText,1,pos(';',szText)-1);
            szText := copy(szText,pos(';',szText)+1,length(szText)-pos(';',szText));
            inc(iColumn);
        end;
        SecondList.Items.Add(ansiuppercase(SGrid.Cells[0,iI])+'.'+SGrid.cells[1,iI]);
    end;
end;

{**************************************************
    Tekij:
        Jari Hakkola/ Oikeat Oliot Oy

    Pivmr:
        20.08.1999

    Kuvaus:
        Funktio hakee annetun tiedoston luonti- ja muutos-
        ajat (pivmr ja kellonaika), tiedoston koon
        tavuina sek tiedoston attribuutit.

    Parameterit:
        szTiedostoNimi: string: Tiedoston nimi, josta tiedot
            haetaan.
        szLuontiPvm: string: Parametrissa palautetaan tiedoston
            luontipiv.
        szMuutosPvm: string: Parametrissa palautetaan tiedoston
            edellinen muutospiv.
        szLuontiAika: string: Parametrissa palautetaan tiedoston
            luontiaika muodossa hh:min:ss.
        szMuutosAika: string: Parametrissa palautetaan tiedoston
            edellinen muutpoaika hh:min:ss.
        fKoko: double: Tiedoston koko tavuina.

    Paluuarvo (integer):
        Jos kaikki menee hyvin, niin funktio palauttaa arvonaan
        vakion yl_lib.OK. Jos tiedostoa ei lytynyt, niin
        funktio palauttaa vakion yl_lib.EI_LOYTYNYT. Jos taas
        jotain muuta menee pieleen, niin funkito palauttaa
        virheen -1;

    Muutokset:
    ***********************************************************************}
function GetFileInfo(szFileName:string; var szCreatedDate: String;
    var szUpdatedDate: String; var szCreatedTime: String;
    var szUpdatedTime: String; var fSize: double):  Boolean;
var hFile: THandle;
    lpFileData: TWin32FindData;
    lpFileTime: TFileTime;
    FileNameArray: array [0..MAX_PATH] of char;

    {****************************************************************
         Kuvaus:
             Funktio muuntaa annetun TFileTime strukturin TSystemTime
             strukturiksi, ja muodostaa sielt lytyvist tiedoista
             palautettavan pivmrn tai kellonajan.

         Paluuarvo(integer):
             Jos kaikki menee hyvin, niin funktio palauttaa 0, muuten
             -1.
     ****************************************************************}
    Function PvmToStr(ft: TFiletime; var szDate: String;
            szType: String): Boolean;
        var lpSystemTime: TSystemTime;
            pvm, kk, vv, hh, min, ss: word;
            szHh, szMin, szSs: String;
        begin
            { Muunnetaan annetun FILETIME- struktuurin kentt SYSTEMTIME-
              struktuuriksi, ja pilkotaan sielt saadut arvot pivmrksi.
            }
            result := false;
            if not windows.FileTimeToSystemTime(lpFileTime, lpSystemTime) then
                exit
            else
            begin
                if szType = 'DATE' then
                    begin
                    pvm := lpSystemTime.wDay;
                    kk := lpSystemTime.wMonth;
                    vv := lpSystemTime.wYear;
                    szDate :=  IntToStr(pvm) + DateSeparator + IntToStr(kk) + DateSeparator + IntToStr(vv);
                    end
                else
                    if szType = 'TIME' then
                        begin
                        hh := lpSystemTime.wHour;
                        min := lpSystemTime.wMinute;
                        ss := lpSystemTime.wSecond;

                    { Jos tunnit, minutit tai sekunnit ovat alta kymmenen,
                      niin listn etunolla, jolloin lopputulos nytt
                      paremmalta.
                    }
                        if hh < 10 then
                            szHh := '0' + IntToStr(hh)
                        else
                            szHh := IntToStr(hh);

                        if min < 10 then
                            szMin := '0' + IntToStr(min)
                        else
                            szMin := IntToStr(min);

                        if ss < 10 then
                            szSs := '0' + IntToStr(ss)
                        else
                            szSs := IntToStr(ss);

                        szDate :=  szHh + TimeSeparator + szMin + TimeSeparator + szSs;
                        end;
            Result := true;
            end;
        end;
    begin
        result := false;
        StrPCopy(FileNameArray,szFileName);
        hFile := windows.FindFirstFile(FileNameArray, lpFileData);
        if hFile = windows.INVALID_HANDLE_VALUE then
            exit
        else
        begin
            { Haetaan tiedoston alkuperinen luontipvm.}
            windows.FileTimeToLocalFileTime(lpFileData.ftCreationTime, lpFileTime);
            if not PvmToStr(lpFileTime, szCreatedDate, 'DATE') then
            begin
                windows.FindClose(hFile);
                exit;
            end;
            { Haetaan tiedoston edellinen muutospiv.}
            windows.FileTimeToLocalFileTime(lpFileData.ftLastWriteTime, lpFileTime);
            if not PvmToStr(lpFileTime, szUpdatedDate, 'DATE') then
            begin
                windows.FindClose(hFile);
                exit;
            end;
            { Haetaan tiedoston alkuperinen luontiaika.}
            windows.FileTimeToLocalFileTime(lpFileData.ftCreationTime, lpFileTime);
            if not PvmToStr(lpFileTime, szCreatedTime, 'TIME') then
            begin
                windows.FindClose(hFile);
                exit;
            end;
            { Haetaan tiedoston edellinen muutosaika.}
            windows.FileTimeToLocalFileTime(lpFileData.ftLastWriteTime, lpFileTime);
            if not PvmToStr(lpFileTime, szUpdatedTime, 'TIME') then
            begin
                windows.FindClose(hFile);
                exit;
            end;

            { Haetaan tiedoston koko tavuina.}
            fSize := (lpFileData.nFileSizeHigh * Windows.MAXDWORD) + lpFileData.nFileSizeLow;
            Result := true;
       end;
end;

procedure SaveGrid(SGrid: TStringGrid; var tfFile: TextFile);
var iI, iJ :Integer;
    szText :String;
begin
    iJ:=1;
    for iI := 1 to SGrid.rowcount - 1 do
        begin
        szText := SGrid.cells[0,iI] + ';' + SGrid.cells[1, iI] + ';' +
            SGrid.cells[2, iI] + ';' + SGrid.cells[3, iI] + ';' +
            SGrid.cells[4, iI] + ';';
        FRMMAIN.Scramble(szText, iJ);
        WriteLn(tfFile, szText);
        inc(iJ);
        if iJ > 3 then
            iJ := 1;
        end;
end;

procedure FillList(SGrid: TStringgrid; List: TFlatListBox;
    DS: TDataSet; szField: String);
var iI: Integer;
    BToList: Boolean;
begin
    with DS do
        begin
        close;
        open;
        end;
    List.Items.clear;
    DS.first;
    while not DS.EOF do
    begin
        // tarkastetaan onko jo gridiss jos on ei laiteta
        BToList := true;
        for iI := 1 to SGrid.rowcount - 1 do
            begin
            if (SGrid.Cells[0,iI] = DMODD.OCIDatabase.ServerName) and
               (SGrid.cells[1,iI] = DS.fieldbyname(szField).asstring) then
                BToList := false;
            end;
        if BToList then
            List.Items.add(DS.FieldByName(szField).asstring);
        DS.next;
    end;
    DS.close;
end;

procedure setButtons(SourceList, DestList: TFlatListBox;
    btnAdd, btAddAll, btnRemove, btnRemoveAll: TFlatButton);
begin
    if not DMODD.OCIDatabase.Connected then
        begin
        btnAdd.Enabled := false;
        btAddAll.Enabled := false;
        btnRemove.Enabled := false;
        btnRemoveAll.Enabled := false;
        exit;
        end;

    if SourceList.Items.Count < 1 then
        begin
        btnAdd.Enabled := false;
        btAddAll.Enabled := false;
        end
    else
        begin
        btnAdd.Enabled := true;
        btAddAll.Enabled := true;
        end;
    if DestList.Items.Count < 1 then
        begin
        btnRemove.Enabled := false;
        btnRemoveAll.Enabled := false;
        end
    else
        begin
        btnRemove.Enabled := true;
        btnRemoveAll.Enabled := true;
        end;
end;

procedure AddToGrid(SGrid: TStringgrid; szText: String; iColumn: Integer);
var BEmpty: Boolean;
    iI: Integer;
begin
    if SGrid.ColCount < iColumn then
        SGrid.colcount := iColumn;

    BEmpty := true;
    if SGrid.cells[iColumn-1, SGrid.rowcount-1] = '' then
    begin
        for iI := iColumn to SGrid.colcount -1 do
            if SGrid.cells[iI, SGrid.rowcount-1] <> '' then
                BEmpty := false;
        if BEmpty then
            SGrid.cells[iColumn-1, SGrid.rowcount-1] := szText
        else
        begin
            SGrid.rowcount := SGrid.rowcount + 1;
            SGrid.cells[iColumn-1, SGrid.rowcount-1] := szText
        end;
    end
    else
    begin
        SGrid.rowcount := SGrid.rowcount + 1;
        SGrid.cells[iColumn-1, SGrid.rowcount-1] := szText
    end;
end;

procedure AppendToGrid(SGrid: TStringgrid; szText: String; iColumn: Integer);
begin
    if SGrid.ColCount < iColumn then
        SGrid.colcount := iColumn;

    SGrid.Cells[iColumn-1, SGrid.rowcount-1] := SGrid.Cells[iColumn-1, SGrid.rowcount-1] + szText
end;

procedure FromGridToMemo(SGrid: TStringgrid; Memo: TMemo;
    CellWidths: array of Integer; BHeader: Boolean; BHtml: Boolean);
var iI, iJ :Integer;
    szText: String;
begin
    if BHtml then
        Memo.Lines.Add('<TABLE BORDER=0>');
    for iI := 0 to SGrid.RowCount - 1 do
    begin
        szText := '';
        if BHtml then
            Memo.Lines.Add('<TR>'); //*
        for iJ :=  0 to SGrid.ColCount - 1 do
            if BHtml then
            begin
                if BHeader then
                begin
                    Memo.Lines.Add('<TD width=' + IntToStr(CellWidths[iJ]) +
                        ' VALIGN=TOP bgcolor="#CCCCCC"><B>' + SGrid.Cells[iJ, iI] +
                        '</B></TD>');
                    if iJ = SGrid.colcount - 1 then
                        BHeader := false
                end
                else
                    Memo.Lines.Add('<TD width=' + IntToStr(CellWidths[iJ]) +
                        ' VALIGN=TOP>' + SGrid.Cells[iJ, iI] + '</TD>') //*
            end
            else
                szText := szText + TrimText(SGrid.cells[iJ, iI],CellWidths[iJ]);

        if BHtml then
           Memo.Lines.Add('</TR>')
        else
        Memo.Lines.Add(szText); //*
    end;
    if BHtml then
        Memo.Lines.Add('</TABLE>'); //*
    EmptyGrid(SGrid);
end;

function TrimText(szText: String; iSize: Integer): String;
var iI: Integer;
    szResult: String;
begin
    szResult := szText;
    for iI := 1 to  iSize - length(szText) do
        szResult := szResult + EMPTYSPACE;
    result := szResult;
end;

procedure setMemoField(MemoField: TFlatMemo; BEnabled: Boolean);
begin
    if not BEnabled then
        begin
            MemoField.ColorFlat := clBtnFace;
            MemoField.Enabled := false;
            MemoField.Text := '';
        end
    else
        begin
            MemoField.ColorFlat := clWindow;
            MemoField.Enabled := true;
        end;
end;

function SelectedIndex(List: TFlatListBox): Integer;
var iI: Integer;
begin
    result := -1;
    for iI := 0 to List.Items.Count - 1 do
        if List.Selected[iI] then
            result := iI;
end;

procedure setFormPosition(Form: TForm; iLeft, iTop, iWidth, iHeight: Integer);
begin
    Form.Left := iLeft + Round((iWidth - Form.Width) / 2);
    Form.Top := iTop + Round((iHeight - Form.Height) / 2);
end;

end.
