unit Oradoc_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, ExtCtrls, Menus, StdCtrls, Buttons, ImgList, Oradoc_lib,
  grids, StdActns, ActnList, Db, hh_funcs, hh;

type
  TFRMMAIN = class(TForm)
    StatusBar: TStatusBar;
    MainMenu: TMainMenu;                              
    MIFile: TMenuItem;
    MIExit: TMenuItem;
    MILine3: TMenuItem;
    MIClose: TMenuItem;
    MISaveAs: TMenuItem;
    MISave: TMenuItem;
    MIOpen: TMenuItem;
    MINew: TMenuItem;
    MIEdit: TMenuItem;
    MIPaste: TMenuItem;
    MICopy: TMenuItem;
    MICut: TMenuItem;
    MIHelp: TMenuItem;
    MIAbout: TMenuItem;
    MIContents: TMenuItem;
    MIView: TMenuItem;
    MIProject: TMenuItem;
    MIBuildproject: TMenuItem;
    MILine4: TMenuItem;
    MIOptions: TMenuItem;
    HotImages: TImageList;
    Images: TImageList;
    PopupMenu: TPopupMenu;
    CoolBar: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolBar2: TToolBar;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    MIToolbar: TMenuItem;
    MILine5: TMenuItem;
    MILine1: TMenuItem;
    MILine2: TMenuItem;
    MIReopen: TMenuItem;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    ActionList1: TActionList;
    EditCopy1: TEditCopy;
    EditCut1: TEditCut;
    EditPaste1: TEditPaste;
    MenuImages: TImageList;
    TempMemo: TMemo;
    TempMemoHeader: TMemo;
    TempGrid: TStringGrid;
    procedure ToolButton6Click(Sender: TObject);
    procedure MIExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MIToolbarClick(Sender: TObject);
    procedure MINewClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MICloseClick(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure MIOpenClick(Sender: TObject);
    procedure MIAboutClick(Sender: TObject);
    procedure MIOptionsClick(Sender: TObject);
    procedure MIBuildprojectClick(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure MISaveClick(Sender: TObject);
    procedure MISaveAsClick(Sender: TObject);
    procedure ToolButton10Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MIContentsClick(Sender: TObject);
    procedure ToolButton11Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
     szProjectFilename: String;
     mHHelp: THookHelpSystem;
     procedure CreateStatusbarPanels;
     procedure NewProject;
     procedure SaveConfirm;
     procedure SetStatusBarWidthToZero;
     procedure SetAppState(State: TAppState);
     procedure EmptyFields;
     function SaveFile(filename: string):boolean;
     procedure AddToHistoryFile(FileName: String);
     function AddToHistoryMenu(MenuItemText: String; onclick: byte): Boolean;
     procedure EmptyHistory(Sender: TObject);
     procedure OpenFileOnClick(Sender: TObject);
     procedure SetMenuCaption(FileName: String);
     procedure OpenFile;
     function ProjectModified: Boolean;
     procedure ReadFile(FileName: String);
     procedure SetFileInfo;
     procedure ReadOptionsFromRegistry;
     procedure WriteOptionsToRegistry;
     procedure AddHistory;
     procedure BuildPageHeader(BHtml: Boolean);
     procedure BuildContent(BHtml: Boolean);
     procedure BuildProject(BHtml: Boolean; var iPart: Integer);
     procedure BuildTables(BHtml: Boolean; var iPart: Integer);
     procedure BuildViews(BHtml: Boolean; var iPart: Integer);
     procedure BuildProcs(BHtml: Boolean; var iPart: Integer);
     procedure BuildPackages(BHtml: Boolean; var iPart: Integer);
     procedure BuildSequences(BHtml: Boolean; var iPart: Integer);
     procedure BuildRoles(BHtml: Boolean; var iPart: Integer);
     function TFCharToBoolean(character: Char): Boolean;
     function BooleanToTFChar(Blean: Boolean): Char;
     procedure Help;
  public
    { Public declarations }
     procedure setModifiedText(text: String);
     procedure setSBConnectText(text: String);
     procedure Scramble(var szText: String; iSeed: Integer);
     procedure DeScramble(var szText: String; iSeed: Integer);
  end;

var
  FRMMAIN: TFRMMAIN;

implementation

uses Oradoc_tab, Oradoc_project, Oradoc_views, Oradoc_procs,
  Oradoc_packages, Oradoc_sequences, Oradoc_roles, Oradoc_about,
  Oradoc_tables, Oradoc_datamodule, Oradoc_options_proctags,
  Oradoc_options_packagetags, Oradoc_options, Oradoc_options_directories,
  Oradoc_progress, Oradoc_options_document, Oradoc_login,
  Oradoc_new_version_number;

{$R *.DFM}

procedure TFRMMAIN.SetStatusBarWidthToZero;
begin
    Statusbar.Panels.items[0].width := 0;
    Statusbar.Panels.items[0].text := '';
    Statusbar.Panels.items[1].width := 0;
    Statusbar.Panels.items[1].text := '';
end;

procedure TFRMMAIN.CreateStatusbarPanels;
begin
    Statusbar.Panels.items[0] := TStatusPanel.Create(StatusBar.Panels);
    Statusbar.Panels.items[1] := TStatusPanel.Create(StatusBar.Panels);
end;

procedure TFRMMAIN.setSBConnectText(text: String);
var tempLabel: TLabel;
    szText: String;
begin
    szText := ansiuppercase(text);
    if szText = Oradoc_lib.EMPTY then
        szText := Oradoc_lib.SBNOTCONNECTEDTEXT;
    tempLabel := TLabel.Create(self);
    tempLabel.Caption := szText;
    Statusbar.Panels.items[0].text := szText;
    Statusbar.Panels.items[0].Width := tempLabel.width+6;
end;

procedure TFRMMAIN.ToolButton6Click(Sender: TObject);
begin
    NewProject;

{FRMTAB.TabPanel.Parent := FRMMAIN;
FRMTAB.FlatTabControlTabChanged(self);

setSBConnectText('TV@mint');
Statusbar.Panels.items[1].text := 'Modified';}
end;

procedure TFRMMAIN.MIExitClick(Sender: TObject);
begin
    close;
end;

procedure TFRMMAIN.FormCreate(Sender: TObject);
begin
    CreateStatusbarPanels;
    height := Oradoc_lib.MAIN_FORM_HEIGHT;
    width := Oradoc_lib.MAIN_FORM_WIDTH;

    Application.HelpFile := 'oradoc.chm';
    mHHelp := THookHelpSystem.Create(
        Stringreplace(Application.exename,'oradoc.exe','',
        [rfReplaceall, rfignoreCase])+'HELP\oradoc.chm','',htHHAPI);
end;

procedure TFRMMAIN.MIToolbarClick(Sender: TObject);
begin
   MIToolbar.Checked := not MIToolbar.Checked;
   Toolbar2.Visible := MIToolbar.Checked;
end;

procedure TFRMMAIN.MINewClick(Sender: TObject);
begin
    NewProject;
end;

procedure TFRMMAIN.SetAppState(State: TAppState);
begin
    case State of
    asProjectNotOpened:
        begin
            FRMTAB.TabPanel.Parent := nil;
            SetStatusBarWidthToZero;
            MIClose.Enabled := false;
            MISave.Enabled := false;
            MISave.ImageIndex := 3;
            MISaveAs.Enabled := false;
            MICut.Enabled := false;
            MICut.ImageIndex := 5;
            MICopy.Enabled := false;
            MICopy.ImageIndex := 7;
            MIPaste.Enabled := false;
            MIPaste.ImageIndex := 9;
            MIBuildproject.Enabled := false;
            ToolButton8.Enabled := false;
            ToolButton10.Enabled := false;
            DMODD.OCIDatabase.Close;
        end;
    asProjectOpened:
        begin
            FRMTAB.TabPanel.Parent := FRMMAIN;
            FRMTAB.FlatTabControl.ActiveTab := 0;
            Oradoc_lib.setMemoField(FRMTABLES.FlatMemo, false);
            Oradoc_lib.setMemoField(FRMVIEWS.FlatMemo, false);
            Oradoc_lib.setMemoField(FRMPACKAGES.FlatMemo, false);
            Oradoc_lib.setMemoField(FRMSEQUENCES.FlatMemo, false);
            Oradoc_lib.setMemoField(FRMROLES.FlatMemo, false);

            {FRMTABLES.PanelTables.Visible := ;
            FRMPROJECT.PanelGeneral.Visible := false;
            FRMVIEWS.PanelViews.Visible := false;
            FRMPROCS.PanelProcs.Visible := false;
            FRMPACKAGES.PanelPackages.Visible := false;
            FRMSEQUENCES.PanelSequences.Visible := false;
            FRMROLES.PanelRoles.Visible := false;     }

            FRMTAB.FlatTabControlTabChanged(self);
            setSBConnectText(Oradoc_lib.SBNOTCONNECTEDTEXT);
            MIClose.Enabled := true;
            MISave.Enabled := true;
            MISave.ImageIndex := 2;
            MISaveAs.Enabled := true;
            MICut.Enabled := true;
            MICut.ImageIndex := 4;
            MICopy.Enabled := true;
            MICopy.ImageIndex := 6;
            MIPaste.Enabled := true;
            MIPaste.ImageIndex := 8;
            MIBuildproject.Enabled := true;
            ToolButton8.Enabled := true;
            ToolButton10.Enabled := true;
            DMODD.OCIDatabase.Close;
        end;
    end;
end;

procedure TFRMMAIN.EmptyFields;
begin
    { Project }
    FRMPROJECT.FEdName.Text := '';
    FRMPROJECT.FEdVersion.Text := '';
    FRMPROJECT.FEdCreated.Text := '';
    FRMPROJECT.FEdUpdated.Text := '';
    FRMPROJECT.FMGeneral.Text := '';
    { Tables }
    FRMTABLES.FlatListBox1.Items.Clear;
    FRMTABLES.FlatListBox2.Items.Clear;
    Oradoc_lib.EmptyGrid(FRMTABLES.StringGrid);
    { Views }
    FRMVIEWS.FlatListBox1.Items.Clear;
    FRMVIEWS.FlatListBox2.Items.Clear;
    Oradoc_lib.EmptyGrid(FRMVIEWS.StringGrid);
    { Procedures and functions }
    FRMPROCS.FlatListBox1.Items.Clear;
    FRMPROCS.FlatListBox2.Items.Clear;
    Oradoc_lib.EmptyGrid(FRMPROCS.StringGrid);
    { Packages }
    FRMPACKAGES.FlatListBox1.Items.Clear;
    FRMPACKAGES.FlatListBox2.Items.Clear;
    Oradoc_lib.EmptyGrid(FRMPACKAGES.StringGrid);
    { Sequences }
    FRMSEQUENCES.FMDescription.Text := '';
    FRMSEQUENCES.FlatListBox1.Items.Clear;
    FRMSEQUENCES.FlatListBox2.Items.Clear;
    Oradoc_lib.EmptyGrid(FRMSEQUENCES.StringGrid);
    { Roles and privileges }
    FRMROLES.FMDescription.Text := '';
    FRMROLES.FlatListBox1.Items.Clear;
    FRMROLES.FlatListBox2.Items.Clear;
    Oradoc_lib.EmptyGrid(FRMROLES.StringGrid);
end;

procedure TFRMMAIN.NewProject;
var szFilename: string;
begin
    SaveConfirm;
    SaveDialog.InitialDir := FRMOPTIONSDIRECTORIES.FEdProjectDirectory.text;
    SaveDialog.FileName := Oradoc_lib.EMPTY;
    SaveDialog.Filter := Oradoc_lib.FILTERTEXTODD;
    SaveDialog.Title := Oradoc_lib.NEWPROJECTTEXT;

    if SaveDialog.Execute then
        begin
        szFilename := SaveDialog.FileName;
        szProjectFilename := SaveDialog.filename;

        { add suffix if user did not }
        if not (pos(ansiuppercase(Oradoc_lib.FILESUFFIX), ansiuppercase(szProjectFilename)) <> 0) then
            szProjectFilename := szProjectFilename + Oradoc_lib.FILESUFFIX;

        while pos(Oradoc_lib.BACKSLASH, szFilename) <> 0 do
            szFilename := copy(szFilename,pos(Oradoc_lib.BACKSLASH, szFilename)+1,length(szFilename)-pos(Oradoc_lib.BACKSLASH,szFilename));

        if pos(ansiuppercase(Oradoc_lib.FILESUFFIX), ansiuppercase(szFilename)) <> 0 then
            szFilename := copy(szFilename, 1, pos(ansiuppercase(Oradoc_lib.FILESUFFIX),
                ansiuppercase(szFilename))-1);


        { Empty all fields before saving the new project }
        EmptyFields;

        FRMPROJECT.FEdName.Text := szFilename;
        FRMPROJECT.FEdVersion.Text := Oradoc_lib.FIRSTVERSIONNUMBER;

        if SaveFile(szProjectFilename) then
            begin
            SetAppState(asProjectOpened);
            SetMenuCaption(szProjectFilename);
            AddToHistoryFile(szProjectFilename);
            end
        else SetAppState(asProjectNotOpened);
    end;
end;

procedure TFRMMAIN.AddToHistoryFile(FileName: String);
var tfFile: TextFile;
begin
    if FileExists(FRMOPTIONSDIRECTORIES.FEdProjectHistory.text) then
    begin
        AssignFile(tfFile, FRMOPTIONSDIRECTORIES.FEdProjectHistory.text);
        Append(tfFile);
        if AddToHistoryMenu(FileName,2) then
        begin
            Writeln(tfFile, FileName);
            Flush(tfFile);  { ensures that the text was actually written to file }
        end;
        CloseFile(tfFile);
    end
    else
    begin
        AssignFile(tfFile, FRMOPTIONSDIRECTORIES.FEdProjectHistory.text);
        rewrite(tfFile);
        try
            writeln(tfFile, FileName);
            MIReOpen.Enabled := true;
            AddToHistoryMenu(Oradoc_lib.EMPTYHISTORY, 1);
            AddToHistoryMenu(Oradoc_lib.HYPHEN, 0);
            AddToHistoryMenu(FileName,2);
        finally
            closefile(tfFile);
        end;
    end;
end;

function TFRMMAIN.AddToHistoryMenu(MenuItemText: String; onclick: byte): Boolean;
var MenuItem, MenuItemPop: TMenuItem;
    BAlreadyInMenu: Boolean;
    iI : Integer;
begin
    BAlreadyInMenu := false;
    for iI := 0 to MIReOpen.count - 1 do
        if ansiuppercase(MIReOpen.Items[iI].caption) = ansiuppercase(MenuItemText) then
            BAlreadyInMenu := true;

    if not BAlreadyInMenu then
        begin
        MenuItem := TMenuItem.Create(application);
        MenuItem.Caption := MenuItemText;
        MenuItemPop := TMenuItem.Create(application);
        MenuItemPop.Caption := MenuItemText;
        case onclick of
        0: begin
           MIReOpen.add(MenuItem);
           PopupMenu.Items.Add(MenuItemPop);
           end;
        1: begin
           MenuItem.onclick := EmptyHistory;
           MenuItemPop.onclick := EmptyHistory;
           MIReOpen.add(MenuItem);
           PopupMenu.Items.Add(MenuItemPop);
           end;
        2: begin
           MenuItem.onclick := OpenFileOnClick;
           MenuItemPop.onclick := OpenFileOnClick;
           MIReOpen.Insert(2, MenuItem);
           { PopupMenu }
           PopupMenu.Items.Insert(2, MenuItemPop);
           end;
        end;
    end;
    result := not BAlreadyInMenu
end;

procedure TFRMMAIN.EmptyHistory(Sender: TObject);
var MenuItem, PopUpMenuItem: TMenuItem;
begin
    with Sender as TMenuItem do
        begin
        while MIReOpen.count <> 0 do
            begin
            MenuItem := MIReOpen.Items[0];
            MenuItem.Free;
            end;

        while PopUpMenu.Items.Count <> 0 do
            begin
            PopUpMenuItem := PopUpMenu.Items[0];
            PopUpMenuItem.Free;
            end;
        MIReOpen.Enabled := false;
        while FileExists(FRMOPTIONSDIRECTORIES.FEdProjectHistory.text) do
            DeleteFile(FRMOPTIONSDIRECTORIES.FEdProjectHistory.text);
        end;
end;

procedure TFRMMAIN.SetMenuCaption(FileName: String);
begin
    if Filename <> '' then
        FRMMAIN.Caption := ansiuppercase(FileName)+' '+
            Oradoc_lib.HYPHEN+' '+Oradoc_lib.MAINFORMCAPTION+
            FRMABOUT.L_VERSION.Caption
    else FRMMAIN.Caption := Oradoc_lib.MAINFORMCAPTION+
            FRMABOUT.L_VERSION.Caption
end;

procedure TFRMMAIN.OpenFileOnClick(Sender: TObject);
var MenuItem: TMenuItem;
begin
    SaveConfirm;
    MenuItem := sender as TMenuItem;
    szProjectFilename := MenuItem.caption;
    SetMenuCaption(MenuItem.caption);
    SetAppState(asProjectOpened);
    ReadFile(MenuItem.caption);
end;

procedure TFRMMAIN.OpenFile;
begin
    SaveConfirm;
    OpenDialog.FileName := '';
    OpenDialog.InitialDir := FRMOPTIONSDIRECTORIES.FEdProjectDirectory.text;
    OpenDialog.Filter := Oradoc_lib.FILTERTEXTODD;
    OpenDialog.Title := Oradoc_lib.OPENPROJECTTEXT;
    if OpenDialog.Execute then
    begin
        szProjectFilename := OpenDialog.FileName;
        SetAppState(asProjectOpened);
        SetMenuCaption(OpenDialog.FileName);
        AddToHistoryFile(OpenDialog.FileName);
        ReadFile(OpenDialog.FileName);
    end;
end;

procedure TFRMMAIN.ReadFile(FileName: String);
var tfFile: TextFile;
    szText: String;
    iRowCount: Integer;
begin
    assignfile(tfFile, FileName);
    try
        reset(tfFile);
        try
            { General }
            ReadLn(tfFile, szText);
            DeScramble(szText, 1);
            FRMPROJECT.FEdName.text := szText;
            ReadLn(tfFile, szText);
            DeScramble(szText, 2);
            FRMPROJECT.FEdVersion.text := szText;
            ReadLn(tfFile, szText);
            DeScramble(szText, 3);
            FRMPROJECT.FMGeneral.text := szText;
            { Tables }
            ReadLn(tfFile, szText);
            DeScramble(szText, 1);
            iRowCount := strtoint(szText);
            Oradoc_lib.LoadGrid(FRMTABLES.StringGrid,
                     FRMTABLES.FlatListBox1,
                     FRMTABLES.FlatListBox2,
                     tfFile, iRowCount);
            { Views }
            ReadLn(tfFile, szText);
            DeScramble(szText, 2);
            iRowCount := strtoint(szText);
            Oradoc_lib.LoadGrid(FRMVIEWS.StringGrid,
                     FRMVIEWS.FlatListBox1,
                     FRMVIEWS.FlatListBox2,
                     tfFile, iRowCount);
            { Procedures and functions }
            ReadLn(tfFile, szText);
            DeScramble(szText, 3);
            iRowCount := strtoint(szText);
            Oradoc_lib.LoadGrid(FRMPROCS.StringGrid,
                     FRMPROCS.FlatListBox1,
                     FRMPROCS.FlatListBox2,
                     tfFile, iRowCount);
            { Packages }
            ReadLn(tfFile, szText);
            DeScramble(szText, 1);
            iRowCount := strtoint(szText);
            Oradoc_lib.LoadGrid(FRMPACKAGES.StringGrid,
                     FRMPACKAGES.FlatListBox1,
                     FRMPACKAGES.FlatListBox2,
                     tfFile, iRowCount);
            { Sequences }
            ReadLn(tfFile, szText);
            DeScramble(szText, 2);
            FRMSEQUENCES.FMDescription.text := szText;
            ReadLn(tfFile, szText);
            DeScramble(szText, 3);
            iRowCount := strtoint(szText);
            Oradoc_lib.LoadGrid(FRMSEQUENCES.StringGrid,
                     FRMSEQUENCES.FlatListBox1,
                     FRMSEQUENCES.FlatListBox2,
                     tfFile, iRowCount);
            { Roles and privileges }
            ReadLn(tfFile, szText);
            DeScramble(szText, 1);
            FRMROLES.FMDescription.text := szText;
            ReadLn(tfFile, szText);
            DeScramble(szText, 2);
            iRowCount := strtoint(szText);
            Oradoc_lib.LoadGrid(FRMROLES.StringGrid,
                     FRMROLES.FlatListBox1,
                     FRMROLES.FlatListBox2,
                     tfFile, iRowCount);
        finally
            closefile(tfFile);
            SetFileInfo;
        end;
    except
        MessageDlg(Format(OPENERROR, [FileName]), mtError, [mbOK], 0);
    end;
end;

procedure TFRMMAIN.SetFileInfo;
var szCreatedDate, szUpdatedDate, szCreatedTime, szUpdatedTime: String;
    fSize: double;
begin
    if Oradoc_lib.GetFileInfo(szProjectFilename, szCreatedDate, szUpdatedDate,
        szCreatedTime, szUpdatedTime, fSize) then
        begin
        FRMPROJECT.FEdCreated.Text := szCreatedDate+' '+szCreatedTime;
        FRMPROJECT.FEdUpdated.Text := szUpdatedDate+' '+szUpdatedTime;
        end;
end;


procedure TFRMMAIN.SaveConfirm;
begin
    if ProjectModified then
        if MessageDlg(Oradoc_lib.SAVECHANGES, mtConfirmation, [mbYes, mbNO], 0) = mrYes then
            SaveFile(szProjectFilename);
end;

procedure TFRMMAIN.setModifiedText(text: String);
begin
    Statusbar.Panels.items[1].text := text;
end;

function TFRMMAIN.ProjectModified: Boolean;
begin
    result := false;
    if Ansiuppercase(Statusbar.Panels.items[1].text) = Ansiuppercase(Oradoc_lib.SBMODIFIEDTEXT) then
        result := true
end;

function TFRMMAIN.SaveFile(FileName: String):boolean;
var tfFile: TextFile;
    szText: String;
begin
    AssignFile(tfFile, FileName);
    try
        ReWrite(tfFile);
        try
            { General }
            szText := FRMPROJECT.FEdName.Text;
            Scramble(szText, 1);
            WriteLn(tfFile, szText);
            szText := FRMPROJECT.FEdVersion.Text;
            Scramble(szText, 2);
            WriteLn(tfFile, szText);
            szText := FRMPROJECT.FMGeneral.text;
            Scramble(szText, 3);
            WriteLn(tfFile, szText);
            { Tables }
            szText := inttostr(FRMTABLES.StringGrid.rowcount - 1);
            Scramble(szText, 1);
            WriteLn(tfFile, szText);
            Oradoc_lib.SaveGrid(FRMTABLES.StringGrid, tfFile);
            { Views }
            szText := inttostr(FRMVIEWS.StringGrid.rowcount - 1);
            Scramble(szText, 2);
            WriteLn(tfFile, szText);
            Oradoc_lib.SaveGrid(FRMVIEWS.StringGrid, tfFile);
            { Procedures and functions }
            szText := inttostr(FRMPROCS.StringGrid.rowcount - 1);
            Scramble(szText, 3);
            WriteLn(tfFile, szText);
            Oradoc_lib.SaveGrid(FRMPROCS.StringGrid, tfFile);
            { Packages }
            szText := inttostr(FRMPACKAGES.StringGrid.rowcount - 1);
            Scramble(szText, 1);
            WriteLn(tfFile, szText);
            Oradoc_lib.SaveGrid(FRMPACKAGES.StringGrid, tfFile);
            { Sequences }
            szText := FRMSEQUENCES.FMDescription.text;
            Scramble(szText, 2);
            WriteLn(tfFile, szText);
            szText := inttostr(FRMSEQUENCES.StringGrid.rowcount - 1);
            Scramble(szText, 3);
            WriteLn(tfFile, szText);
            Oradoc_lib.SaveGrid(FRMSEQUENCES.StringGrid, tfFile);
            { Roles and privileges }
            szText := FRMROLES.FMDescription.text;
            Scramble(szText, 1);
            WriteLn(tfFile, szText);
            szText := inttostr(FRMROLES.StringGrid.rowcount - 1);
            Scramble(szText, 2);
            WriteLn(tfFile, szText);
            Oradoc_lib.SaveGrid(FRMROLES.StringGrid, tfFile);
        finally
            CloseFile(tfFile);
            SetFileInfo;
            setModifiedText(Oradoc_lib.EMPTY);
            Result := true;
        end;
    except
        MessageDlg(Format(Oradoc_lib.CREATEERROR, [FileName]), mtError, [mbOK], 0);
        Result := false;
    end;
end;

function TFRMMAIN.TFCharToBoolean(character: Char): Boolean;
begin
    result := false;
    if character = Oradoc_lib.TRUEVALUE then result := true;
end;

function TFRMMAIN.BooleanToTFChar(Blean: Boolean): Char;
begin
    result := 'F';
    if Blean then result := 'T';
end;

procedure TFRMMAIN.WriteOptionsToRegistry;
var szDocParts: String[Oradoc_lib.DOCPARTCOUNT];
begin
    { set history file }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.HISTORYFILE,
        FRMOPTIONSDIRECTORIES.FEdProjectHistory.text);
    { set initial directory }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PROJECTDIR,
        FRMOPTIONSDIRECTORIES.FEdProjectDirectory.text);
    { set database log history file }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.DBLOGHISTORY,
        FRMOPTIONSDIRECTORIES.FEdDBLogHistory.text);
    { set document }
    szDocParts := BooleanToTFChar(FRMOPTIONSDOCUMENT.FCBContent.Checked);
    szDocParts := szDocParts + BooleanToTFChar(FRMOPTIONSDOCUMENT.FCBProject.Checked);
    szDocParts := szDocParts + BooleanToTFChar(FRMOPTIONSDOCUMENT.FCBTables.Checked);
    szDocParts := szDocParts + BooleanToTFChar(FRMOPTIONSDOCUMENT.FCBViews.Checked);
    szDocParts := szDocParts + BooleanToTFChar(FRMOPTIONSDOCUMENT.FCBProceduresAndFunctions.Checked);
    szDocParts := szDocParts + BooleanToTFChar(FRMOPTIONSDOCUMENT.FCBPackages.Checked);
    szDocParts := szDocParts + BooleanToTFChar(FRMOPTIONSDOCUMENT.FCBSequences.Checked);
    szDocParts := szDocParts + BooleanToTFChar(FRMOPTIONSDOCUMENT.FCBRolesAndPrivileges.Checked);
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.DOCUMENTPARTS, szDocParts);
    { Function tags }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_OPENTAG,
        FRMOPTIONSPROCTAGS.FEdFunctionOpen.text);
    { description }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_DESCRIPTION,
        FRMOPTIONSPROCTAGS.FEdDescription.text);
    { parameters}
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_PARAMETERS,
        FRMOPTIONSPROCTAGS.FEdParameters.text);
    { spot }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUCNTION_SPOT,
        FRMOPTIONSPROCTAGS.FEdSpot.text);
    { colon }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_COLON,
        FRMOPTIONSPROCTAGS.FEdColon.text);
    { semicolon }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_SEMICOLON,
        FRMOPTIONSPROCTAGS.FEdSemiColon.text);
    { return value }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_RETURNVALUE,
        FRMOPTIONSPROCTAGS.FEdReturnValue.text);
    { close tag }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_CLOSETAG,
        FRMOPTIONSPROCTAGS.FEdFunctionClose.text);
    { Package description tags}
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_OPENTAG,
        FRMOPTIONSPACKAGETAGS.FEdPackageOpen.text);
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_DESCRIPTION,
        FRMOPTIONSPACKAGETAGS.FEdDescription1.text);
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_CLOSETAG,
        FRMOPTIONSPACKAGETAGS.FEdPackageClose.text);
    { Function tags }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_OPENTAG,
        FRMOPTIONSPACKAGETAGS.FEdPackageProcOpen.text);
    { function }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION,
        FRMOPTIONSPACKAGETAGS.FEdFunction.text);
    { procedure }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_PROCEDURE,
        FRMOPTIONSPACKAGETAGS.FEdProcedure.text);
    { description }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_DESCRIPTION,
        FRMOPTIONSPACKAGETAGS.FEdDescription2.text);
    { parameters}
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_PARAMETERS,
        FRMOPTIONSPACKAGETAGS.FEdParameters.text);
    { spot }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUCNTION_SPOT,
        FRMOPTIONSPACKAGETAGS.FEdSpot.text);
    { colon }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_COLON,
        FRMOPTIONSPACKAGETAGS.FEdColon.text);
    { semicolon }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_SEMICOLON,
        FRMOPTIONSPACKAGETAGS.FEdSemiColon.text);
    { return value }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_RETURNVALUE,
        FRMOPTIONSPACKAGETAGS.FEdReturnValue.text);
    { close tag }
    Oradoc_lib.WriteValuetoRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_CLOSETAG,
        FRMOPTIONSPACKAGETAGS.FEdPackageProcClose.text);
end;

procedure TFRMMAIN.ReadOptionsFromRegistry;
var szDocParts: String[Oradoc_lib.DOCPARTCOUNT];
begin
    { set history file }
    FRMOPTIONSDIRECTORIES.FEdProjectHistory.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.HISTORYFILE);
    if FRMOPTIONSDIRECTORIES.FEdProjectHistory.text = Oradoc_lib.EMPTY then
        FRMOPTIONSDIRECTORIES.FEdProjectHistory.text := ExtractFileDir(ParamStr(0))+Oradoc_lib.BACKSLASH+Oradoc_lib.DEF_HISTORYFILE;
    { set initial directory }
    FRMOPTIONSDIRECTORIES.FEdProjectDirectory.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PROJECTDIR);
    if FRMOPTIONSDIRECTORIES.FEdProjectDirectory.text = Oradoc_lib.EMPTY then
        FRMOPTIONSDIRECTORIES.FEdProjectDirectory.text := ExtractFileDir(ParamStr(0))+Oradoc_lib.BACKSLASH;
    { set database log history file }
    FRMOPTIONSDIRECTORIES.FEdDBLogHistory.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.DBLOGHISTORY);
    if FRMOPTIONSDIRECTORIES.FEdDBLogHistory.text = Oradoc_lib.EMPTY then
        FRMOPTIONSDIRECTORIES.FEdDBLogHistory.text := ExtractFileDir(ParamStr(0))+Oradoc_lib.BACKSLASH+Oradoc_lib.DEF_DBLOGHISTORY;
    { set document }
    szDocParts := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.DOCUMENTPARTS);
    if szDocParts = Oradoc_lib.EMPTY then
        szDocParts := Oradoc_lib.DEF_DOCUMENTPARTS;

    FRMOPTIONSDOCUMENT.FCBContent.Checked := TFCharToBoolean(szDocParts[1]);
    FRMOPTIONSDOCUMENT.FCBProject.Checked := TFCharToBoolean(szDocParts[2]);
    FRMOPTIONSDOCUMENT.FCBTables.Checked := TFCharToBoolean(szDocParts[3]);
    FRMOPTIONSDOCUMENT.FCBViews.Checked := TFCharToBoolean(szDocParts[4]);
    FRMOPTIONSDOCUMENT.FCBProceduresAndFunctions.Checked := TFCharToBoolean(szDocParts[5]);
    FRMOPTIONSDOCUMENT.FCBPackages.Checked := TFCharToBoolean(szDocParts[6]);
    FRMOPTIONSDOCUMENT.FCBSequences.Checked := TFCharToBoolean(szDocParts[7]);
    FRMOPTIONSDOCUMENT.FCBRolesAndPrivileges.Checked := TFCharToBoolean(szDocParts[8]);

    { Function tags }
    FRMOPTIONSPROCTAGS.FEdFunctionOpen.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_OPENTAG);
    if FRMOPTIONSPROCTAGS.FEdFunctionOpen.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPROCTAGS.FEdFunctionOpen.text := Oradoc_lib.DEF_FUNCTION_OPENTAG;
    { description }
    FRMOPTIONSPROCTAGS.FEdDescription.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_DESCRIPTION);
    if FRMOPTIONSPROCTAGS.FEdDescription.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPROCTAGS.FEdDescription.text := Oradoc_lib.DEF_FUNCTION_DESCRIPTION;
    { parameters}
    FRMOPTIONSPROCTAGS.FEdParameters.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_PARAMETERS);
    if FRMOPTIONSPROCTAGS.FEdParameters.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPROCTAGS.FEdParameters.text := Oradoc_lib.DEF_FUNCTION_PARAMETERS;
    { spot }
    FRMOPTIONSPROCTAGS.FEdSpot.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUCNTION_SPOT);
    if FRMOPTIONSPROCTAGS.FEdSpot.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPROCTAGS.FEdSpot.text := Oradoc_lib.DEF_FUCNTION_SPOT;
    { colon }
    FRMOPTIONSPROCTAGS.FEdColon.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_COLON);
    if FRMOPTIONSPROCTAGS.FEdColon.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPROCTAGS.FEdColon.text := Oradoc_lib.DEF_FUNCTION_COLON;
    { semicolon }
    FRMOPTIONSPROCTAGS.FEdSemiColon.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_SEMICOLON);
    if FRMOPTIONSPROCTAGS.FEdSemiColon.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPROCTAGS.FEdSemiColon.text := Oradoc_lib.DEF_FUNCTION_SEMICOLON;
    { return value }
    FRMOPTIONSPROCTAGS.FEdReturnValue.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_RETURNVALUE);
    if FRMOPTIONSPROCTAGS.FEdReturnValue.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPROCTAGS.FEdReturnValue.text := Oradoc_lib.DEF_FUNCTION_RETURNVALUE;
    { close tag }
    FRMOPTIONSPROCTAGS.FEdFunctionClose.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.FUNCTION_CLOSETAG);
    if FRMOPTIONSPROCTAGS.FEdFunctionClose.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPROCTAGS.FEdFunctionClose.text := Oradoc_lib.DEF_FUNCTION_CLOSETAG;
    { Package description tags}
    FRMOPTIONSPACKAGETAGS.FEdPackageOpen.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_OPENTAG);
    if FRMOPTIONSPACKAGETAGS.FEdPackageOpen.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdPackageOpen.text := Oradoc_lib.DEF_PACKAGE_OPENTAG;
    FRMOPTIONSPACKAGETAGS.FEdDescription1.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_DESCRIPTION);
    if FRMOPTIONSPACKAGETAGS.FEdDescription1.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdDescription1.text := Oradoc_lib.DEF_PACKAGE_DESCRIPTION;
    FRMOPTIONSPACKAGETAGS.FEdPackageClose.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_CLOSETAG);
    if FRMOPTIONSPACKAGETAGS.FEdPackageClose.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdPackageClose.text := Oradoc_lib.DEF_PACKAGE_CLOSETAG;
    { Function tags }
    FRMOPTIONSPACKAGETAGS.FEdPackageProcOpen.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_OPENTAG);
    if FRMOPTIONSPACKAGETAGS.FEdPackageProcOpen.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdPackageProcOpen.text := Oradoc_lib.DEF_PACKAGE_FUNCTION_OPENTAG;
    { function }
    FRMOPTIONSPACKAGETAGS.FEdFunction.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION);
    if FRMOPTIONSPACKAGETAGS.FEdFunction.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdFunction.text := Oradoc_lib.DEF_PACKAGE_FUNCTION;
    { procedure }
    FRMOPTIONSPACKAGETAGS.FEdProcedure.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_PROCEDURE);
    if FRMOPTIONSPACKAGETAGS.FEdProcedure.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdProcedure.text := Oradoc_lib.DEF_PACKAGE_PROCEDURE;
    { description }
    FRMOPTIONSPACKAGETAGS.FEdDescription2.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_DESCRIPTION);
    if FRMOPTIONSPACKAGETAGS.FEdDescription2.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdDescription2.text := Oradoc_lib.DEF_PACKAGE_FUNCTION_DESCRIPTION;
    { parameters}
    FRMOPTIONSPACKAGETAGS.FEdParameters.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_PARAMETERS);
    if FRMOPTIONSPACKAGETAGS.FEdParameters.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdParameters.text := Oradoc_lib.DEF_PACKAGE_FUNCTION_PARAMETERS;
    { spot }
    FRMOPTIONSPACKAGETAGS.FEdSpot.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUCNTION_SPOT);
    if FRMOPTIONSPACKAGETAGS.FEdSpot.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdSpot.text := Oradoc_lib.DEF_PACKAGE_FUCNTION_SPOT;
    { colon }
    FRMOPTIONSPACKAGETAGS.FEdColon.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_COLON);
    if FRMOPTIONSPACKAGETAGS.FEdColon.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdColon.text := Oradoc_lib.DEF_PACKAGE_FUNCTION_COLON;
    { semicolon }
    FRMOPTIONSPACKAGETAGS.FEdSemiColon.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_SEMICOLON);
    if FRMOPTIONSPACKAGETAGS.FEdSemiColon.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdSemiColon.text := Oradoc_lib.DEF_PACKAGE_FUNCTION_SEMICOLON;
    { return value }
    FRMOPTIONSPACKAGETAGS.FEdReturnValue.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_RETURNVALUE);
    if FRMOPTIONSPACKAGETAGS.FEdReturnValue.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdReturnValue.text := Oradoc_lib.DEF_PACKAGE_FUNCTION_RETURNVALUE;
    { close tag }
    FRMOPTIONSPACKAGETAGS.FEdPackageProcClose.text := Oradoc_lib.ReadValuefromRegistry(Oradoc_lib.REGISTRYPATH,
        Oradoc_lib.REGISTRYKEY, Oradoc_lib.PACKAGE_FUNCTION_CLOSETAG);
    if FRMOPTIONSPACKAGETAGS.FEdPackageProcClose.text = Oradoc_lib.EMPTY then
        FRMOPTIONSPACKAGETAGS.FEdPackageProcClose.text := Oradoc_lib.DEF_PACKAGE_FUNCTION_CLOSETAG;
end;

procedure TFRMMAIN.FormShow(Sender: TObject);
begin
    SetAppState(asProjectNotOpened);
    { Get tags, paths etc from registry }
    ReadOptionsFromRegistry;
    MIReOpen.Enabled := false;
    AddHistory;
    SetMenuCaption('');
end;

procedure TFRMMAIN.AddHistory;
var tfFile: TextFile;
    FileName: String;
begin
    if FileExists(FRMOPTIONSDIRECTORIES.FEdProjectHistory.text) then
        begin
        AssignFile(tfFile, FRMOPTIONSDIRECTORIES.FEdProjectHistory.text);
        try
            Reset(tfFile);
            MIReOpen.Enabled := true;
            AddToHistoryMenu(Oradoc_lib.EMPTYHISTORY, 1);
            AddToHistoryMenu(Oradoc_lib.HYPHEN, 0);
            while not eof(tfFile) do
                begin
                ReadLn(tfFile, FileName);
                // chr 1,2,3..., a,b,
                AddToHistoryMenu(FileName, 2);
                end;
        finally
            CloseFile(tfFile);
        end;
        end;
end;


procedure TFRMMAIN.MICloseClick(Sender: TObject);
begin
    SaveConfirm;
    SetAppState(asProjectNotOpened);
    SetMenuCaption('');
end;

procedure TFRMMAIN.ToolButton7Click(Sender: TObject);
begin
    OpenFile;
end;

procedure TFRMMAIN.MIOpenClick(Sender: TObject);
begin
    OpenFile;
end;

procedure TFRMMAIN.MIAboutClick(Sender: TObject);
begin
    Oradoc_lib.setFormPosition(FRMABOUT, left, top, width, height);
    FRMABOUT.showmodal
end;

procedure TFRMMAIN.MIOptionsClick(Sender: TObject);
begin
    Oradoc_lib.setFormPosition(FRMOPTIONS, left, top, width, height);
    if FRMOPTIONS.showmodal = mrOk then
        begin
        WriteOptionsToRegistry;
        AddHistory;
        end;
end;

procedure TFRMMAIN.BuildPageHeader(BHtml: Boolean);
begin
    if BHtml then
        TempMemoHeader.Lines.Add('<HTML><BODY BGCOLOR="#FAFAFA">');
    if BHtml then TempMemoHeader.Lines.Add('<H3>');
    TempMemoHeader.Lines.Add('Oracle Database Document');
    if BHtml then TempMemoHeader.Lines.Add('</H3>');
    if not BHtml then TempMemoHeader.Lines.Add('');
    TempMemoHeader.Lines.Add('Name '+FRMPROJECT.FEdName.Text);
    if BHtml then TempMemoHeader.Lines.Add('<BR>');
    TempMemoHeader.Lines.Add('Version '+FRMPROJECT.FEdVersion.Text);
    if BHtml then TempMemoHeader.Lines.Add('<BR>');
    TempMemoHeader.Lines.Add('Created '+FRMPROJECT.FEdCreated.Text);
    if BHtml then TempMemoHeader.Lines.Add('<BR>');
    TempMemoHeader.Lines.Add('Updated '+FRMPROJECT.FEdUpdated.Text);
    if not BHtml then TempMemoHeader.Lines.Add('');
    if BHtml then TempMemoHeader.Lines.Add('<hr>');
end;

procedure TFRMMAIN.BuildContent(BHtml: Boolean);
begin
    if BHtml then
        TempMemoHeader.Lines.Add('<H3>');
    TempMemoHeader.Lines.Add('Content');
    if BHtml then
        TempMemoHeader.Lines.Add('</H3>');
end;

procedure TFRMMAIN.BuildProject(BHtml: Boolean; var iPart: Integer);
var iI: Integer;
szText: String;
begin
    if BHtml then
        TempMemo.Lines.Add('<H3>');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('<A NAME="'+IntToStr(iPart)+'">');
    TempMemo.Lines.Add(IntToStr(iPart)+' General');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('</A>');
    if BHtml then
        TempMemo.Lines.Add('</H3>');

    if FRMOPTIONSDOCUMENT.FCBContent.Checked then
        begin
        if BHtml then
            TempMemoHeader.Lines.Add('<P><B><A HREF="#'+IntToStr(iPart)+'">');
        TempMemoHeader.Lines.Add(IntToStr(iPart)+' General');
        if BHtml then
            TempMemoHeader.Lines.Add('</A></B></P>');
        end;
        
    inc(iPart);

    if not BHtml then
        TempMemo.Lines.Add('');

    if BHtml then
        TempMemo.Lines.Add('<P>');

    if BHtml then
        begin
        szText := FRMPROJECT.FMGeneral.text;
        while pos(#13, szText) <> 0 do
            begin
                iI := pos(#13, szText);
                delete(szText, iI, 1);
                insert('</P><P>', szText, iI);
            end;
        TempMemo.Lines.Add(szText);
        end
    else
        TempMemo.Lines.Add(FRMPROJECT.FMGeneral.text);

    if BHtml then
        TempMemo.Lines.Add('</P>');
    if not BHtml then
        TempMemo.Lines.Add('')
    else TempMemo.Lines.Add('<HR>');
end;

procedure TFRMMAIN.BuildTables(BHtml: Boolean; var iPart: Integer);
var iI: Integer;
    previousUser, previousPassword, previousDatabase: String;
begin
    if BHtml then
        TempMemo.Lines.Add('<H3>');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('<A NAME = "'+IntToStr(iPart)+'">');
    TempMemo.Lines.Add(IntToStr(iPart)+' Tables');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('</A>');
    if BHtml then
        TempMemo.Lines.Add('</H3>');

    if FRMOPTIONSDOCUMENT.FCBContent.Checked then
        begin
        if BHtml then
            TempMemoHeader.Lines.Add('<P><B><A HREF="#'+IntToStr(iPart)+'">');
        TempMemoHeader.Lines.Add(IntToStr(iPart)+' Tables');
        if BHtml then
            TempMemoHeader.Lines.Add('</A></B><BR>');
        end;

    if not BHtml then
        TempMemo.Lines.Add('');

    if FRMTABLES.StringGrid.rowcount - 1 > 0 then
    begin
        previousDatabase := '';
        previousUser := '';
        previousPassword := '';
        for iI := 1 to FRMTABLES.StringGrid.RowCount - 1 do
        begin
            FRMPROGRESS.setInfoText('Building table: ' + chr(13) +
                 chr(10) + FRMTABLES.StringGrid.cells[1, iI]);
            FRMPROGRESS.increasePosition(1);
            FRMPROGRESS.Refresh;

            if (previousDatabase <> FRMTABLES.StringGrid.cells[0, iI]) or
               (previousUser <> FRMTABLES.StringGrid.cells[2, iI]) or
               (previousPassword <> FRMTABLES.StringGrid.cells[3, iI]) then
               begin
                FRMLOGIN.Login(FRMTABLES.StringGrid.cells[0, iI],
                    FRMTABLES.StringGrid.cells[2, iI],
                    FRMTABLES.StringGrid.cells[3, iI]);
                previousDatabase := FRMTABLES.StringGrid.cells[0, iI];
                previousUser := FRMTABLES.StringGrid.cells[2, iI];
                previousPassword := FRMTABLES.StringGrid.cells[3, iI];
               end;

            with DMODD.OCISynonyms do
            begin
                close;
                Params[0].ParamType := ptInput;
                Params[0].DataType := ftString;
                Params[0].AsString := FRMTABLES.StringGrid.cells[1, iI];
                open;
            end;
            if BHtml then
                TempMemo.Lines.Add('<H4>');
            if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
                TempMemo.Lines.Add('<A NAME="'+IntToStr(iPart)+'.'+inttostr(iI)+'">');
            TempMemo.Lines.Add(IntToStr(iPart)+'.'+inttostr(iI)+' '+FRMTABLES.StringGrid.cells[1, iI]);
            if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
                TempMemo.Lines.Add('</A>');
            if BHtml then
                TempMemo.Lines.Add('</H4>');

            if FRMOPTIONSDOCUMENT.FCBContent.Checked then
                begin
                if BHtml then
                    TempMemoHeader.Lines.Add(Oradoc_lib.HTMLTAB+'<I><A HREF="#'+IntToStr(iPart)+'.'+inttostr(iI)+'">');
                TempMemoHeader.Lines.Add(IntToStr(iPart)+'.'+inttostr(iI)+' '+FRMTABLES.StringGrid.cells[1, iI]);
                if BHtml then
                    TempMemoHeader.Lines.Add('</A></I><BR>');
                end;

            if not BHtml then
                TempMemo.Lines.Add('');

            if not DMODD.OCISynonyms.IsEmpty then
                begin
                if BHtml then
                    TempMemo.Lines.Add('<H5>');
                TempMemo.Lines.Add('Synonym');
                if BHtml then
                    TempMemo.Lines.Add('</H5>');
                if not BHtml then
                    TempMemo.Lines.Add('');
                if BHtml then
                    TempMemo.Lines.Add('<P>');
                TempMemo.Lines.Add(DMODD.OCISynonyms.fieldbyname('synonym_name').asstring);
                DMODD.OCISynonyms.Close;
                if BHtml then
                    TempMemo.Lines.Add('</P>');
                if not BHtml then
                    TempMemo.Lines.Add('');
                end;

            if FRMTABLES.StringGrid.cells[4, iI] <> Oradoc_lib.EMPTY then
                begin
                if BHtml then
                    TempMemo.Lines.Add('<H5>');
                TempMemo.Lines.Add('Description');
                if BHtml then
                    TempMemo.Lines.Add('</H5>');
                if not BHtml then
                    TempMemo.Lines.Add('');
                if BHtml then
                    TempMemo.Lines.Add('<P>');
                TempMemo.Lines.Add(FRMTABLES.StringGrid.cells[4, iI]);
                if BHtml then
                    TempMemo.Lines.Add('</P>');
                if not BHtml then
                    TempMemo.Lines.Add('');
                end;
            if BHtml then
                TempMemo.Lines.Add('<H5>');
            TempMemo.Lines.Add('Columns');
            if BHtml then
                TempMemo.Lines.Add('</H5>');
            if not BHtml then
                TempMemo.Lines.Add('');
            Oradoc_lib.AddToGrid(TempGrid,'Name',1);
            Oradoc_lib.AddToGrid(TempGrid,'Type',2);
            Oradoc_lib.AddToGrid(TempGrid,'Null?',3);
            Oradoc_lib.AddToGrid(TempGrid,'Description',4);
            with DMODD.OCITableFields do
            begin
                close;
                Params[0].ParamType := ptInput;
                Params[0].DataType := ftString;
                Params[0].AsString := FRMTABLES.StringGrid.cells[1, iI];
                open;
                first;
                while not eof do
                begin
                    Oradoc_lib.AddToGrid(TempGrid, FieldByName('kentta').asString,1);
                    Oradoc_lib.AddToGrid(TempGrid, FieldByName('tyyppi').asString,2);
                    Oradoc_lib.AddToGrid(TempGrid, FieldByName('nulli').asString,3);
                    Oradoc_lib.AddToGrid(TempGrid, FieldByName('kuvaus').asString,4);
                    next;
                end;
                close;
            end;
            if BHtml then
                Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [300,150,100,0], true, true)
            else
                Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [30,15,15,15], true, false);
            if not BHtml then
                TempMemo.Lines.Add('');


            with DMODD.OCIPrimaryKeys do
                begin
                close;
                Params[0].ParamType := ptInput;
                Params[0].DataType := ftString;
                Params[0].AsString := FRMTABLES.StringGrid.cells[1, iI];
                open;
                if not isempty then
                    begin
                    if BHtml then
                        TempMemo.Lines.Add('<H5>');
                    TempMemo.Lines.Add('Primary keys');
                    if BHtml then
                        TempMemo.Lines.Add('</H5>');
                    if BHtml then
                        TempMemo.Lines.Add('<P>');
                    if not BHtml then
                        TempMemo.Lines.Add('');
                    Oradoc_lib.AddToGrid(TempGrid, 'Name',1);
                    Oradoc_lib.AddToGrid(TempGrid, 'Column',2);

                    first;
                    while not eof do
                        begin
                        Oradoc_lib.AddToGrid(TempGrid, FieldByName('Nimi').asString, 1);
                        Oradoc_lib.AddToGrid(TempGrid, FieldByName('Sarake').asString, 2);
                        next;
                        end;
                    close;
                    if BHtml then
                        Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [200,300], true, true)
                    else
                        Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [30,15], true, false);
                    if BHtml then
                        TempMemo.Lines.Add('</P>');

                    if not BHtml then
                        TempMemo.Lines.Add('');
                    end;
                end;


            with DMODD.OCIForeignKeys do
                begin
                close;
                Params[0].ParamType := ptInput;
                Params[0].DataType := ftString;
                Params[0].AsString := FRMTABLES.StringGrid.cells[1,iI];
                open;
                if not isempty then
                    begin
                    if BHtml then
                        TempMemo.Lines.Add('<H5>');
                    TempMemo.Lines.Add('Foreign keys');
                    if BHtml then
                        TempMemo.Lines.Add('</H5>');
                    if not BHtml then
                        TempMemo.Lines.Add('');
                    if BHtml then
                        TempMemo.Lines.Add('<P>');
                    Oradoc_lib.AddToGrid(TempGrid, 'Name',1);
                    Oradoc_lib.AddToGrid(TempGrid, 'From Column',2);
                    Oradoc_lib.AddToGrid(TempGrid, 'To Column',3);
                    first;
                    while not eof do
                        begin
                        Oradoc_lib.AddToGrid(TempGrid, FieldByName('Nimi').asString, 1);
                        Oradoc_lib.AddToGrid(TempGrid, FieldByName('Lahtosarake').asString, 2);
                        Oradoc_lib.AddToGrid(TempGrid, FieldByName('Kohdesarake').asString, 3);
                        next;
                        end;
                    close;
                    if BHtml then
                        Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [200,250,0], true, true)
                    else
                        Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [20,30,30], true, false);
                    if not BHtml then
                        TempMemo.Lines.Add('');

                    end;
                end;

            with DMODD.OCIIndexes do
            begin
                close;
                Params[0].ParamType := ptInput;
                Params[0].DataType := ftString;
                Params[0].AsString := FRMTABLES.StringGrid.cells[1,iI];
                open;
                if not isempty then
                    begin
                    if BHtml then
                        TempMemo.Lines.Add('<H5>');
                    TempMemo.Lines.Add('Indexes');
                    if BHtml then
                        TempMemo.Lines.Add('</H5>');
                    if not BHtml then
                        TempMemo.Lines.Add('');
                    if BHtml then
                        TempMemo.Lines.Add('<P>');
                    Oradoc_lib.AddToGrid(TempGrid, 'Name', 1);
                    Oradoc_lib.AddToGrid(TempGrid, 'Column', 2);
                    first;
                    while not eof do
                        begin
                        Oradoc_lib.AddToGrid(TempGrid, fieldbyname('Nimi').asstring, 1);
                        Oradoc_lib.AddToGrid(TempGrid, fieldbyname('sarake').asstring, 2);
                        next;
                        end;
                    close;
                    if BHtml then
                        Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [200,300], true, true)
                    else
                        Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [20,30], true, false);
                    if not BHtml then
                        TempMemo.Lines.Add('');

                    end;
                end;
         end;
     end;
     if BHtml then
        TempMemoHeader.Lines.Add('</P>');
     if not BHtml then
         TempMemo.Lines.Add('')
     else TempMemo.Lines.Add('<HR>');
     inc(iPart);
end;

procedure TFRMMAIN.BuildViews(BHtml: Boolean; var iPart: Integer);
var iI: Integer;
    previousUser, previousPassword, previousDatabase,
    szText, szRow: String;
begin
    if BHtml then
        TempMemo.Lines.Add('<H3>');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('<A NAME="'+IntToStr(iPart)+'">');
    TempMemo.Lines.Add(IntToStr(iPart)+' Views');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('</A>');
    if BHtml then
        TempMemo.Lines.Add('</H3>');

    if FRMOPTIONSDOCUMENT.FCBContent.Checked then
        begin
        if BHtml then
            TempMemoHeader.Lines.Add('<P><B><A HREF="#'+IntToStr(iPart)+'">');
        TempMemoHeader.Lines.Add(IntToStr(iPart)+' Views');
        if BHtml then
            TempMemoHeader.Lines.Add('</A></B><BR>');
        end;
    if not BHtml then
        TempMemo.Lines.Add('');

    if FRMVIEWS.StringGrid.rowcount - 1 > 0 then
        begin
            previousDatabase := '';
            previousUser := '';
            previousPassword := '';
            for iI := 1 to FRMVIEWS.StringGrid.RowCount - 1 do
            begin
                FRMPROGRESS.setInfoText('Building view: ' + chr(13) +
                     chr(10) + FRMVIEWS.StringGrid.cells[1, iI]);
                FRMPROGRESS.increasePosition(1);
                FRMPROGRESS.Refresh;

                if (previousDatabase <> FRMVIEWS.StringGrid.cells[0, iI]) or
                   (previousUser <> FRMVIEWS.StringGrid.cells[2, iI]) or
                   (previousPassword <> FRMVIEWS.StringGrid.cells[3, iI]) then
                    begin
                    FRMLOGIN.Login(FRMVIEWS.StringGrid.cells[0, iI],
                        FRMVIEWS.StringGrid.cells[2, iI],
                        FRMVIEWS.StringGrid.cells[3, iI]);
                    previousDatabase := FRMVIEWS.StringGrid.cells[0, iI];
                    previousUser := FRMVIEWS.StringGrid.cells[2, iI];
                    previousPassword := FRMVIEWS.StringGrid.cells[3, iI];
                    end;

                if BHtml then
                    TempMemo.Lines.Add('<H4>');
                if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
                    TempMemo.Lines.Add('<A NAME="'+IntToStr(iPart)+'.'+inttostr(iI)+'">');
                TempMemo.Lines.Add(IntToStr(iPart)+'.'+inttostr(iI)+' '+FRMVIEWS.StringGrid.cells[1, iI]);
                if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
                    TempMemo.Lines.Add('</A>');
                if BHtml then
                    TempMemo.Lines.Add('</H4>');

                if FRMOPTIONSDOCUMENT.FCBContent.Checked then
                    begin
                    if BHtml then
                        TempMemoHeader.Lines.Add(Oradoc_lib.HTMLTAB+'<I><A HREF="#'+IntToStr(iPart)+'.'+inttostr(iI)+'">');
                    TempMemoHeader.Lines.Add(IntToStr(iPart)+'.'+inttostr(iI)+' '+FRMVIEWS.StringGrid.cells[1, iI]);
                    if BHtml then
                        TempMemoHeader.Lines.Add('</A></I><BR>');
                    end;

                if not BHtml then
                    TempMemo.Lines.Add('');

                if FRMVIEWS.StringGrid.Cells[4, iI] <> Oradoc_lib.EMPTY then
                    begin
                    if BHtml then
                        TempMemo.Lines.Add('<H5>');
                    TempMemo.Lines.Add('Description');
                    if BHtml then
                        TempMemo.Lines.Add('</H5>');
                    if not BHtml then
                        TempMemo.Lines.Add('');
                    if BHtml then
                        TempMemo.Lines.Add('<P>');
                    TempMemo.Lines.Add(FRMVIEWS.StringGrid.Cells[4, iI]);
                    if BHtml then
                        TempMemo.Lines.Add('</P>');
                    if not BHtml then
                        TempMemo.Lines.Add('');
                    end;
                if BHtml then
                    TempMemo.Lines.Add('<H5>');
                TempMemo.Lines.Add('Creation script');
                if BHtml then
                    TempMemo.Lines.Add('</H5>');
                if not BHtml then
                    TempMemo.Lines.Add('');
                with DMODD.OCIViews do
                    begin
                    close;
                    Params[0].ParamType := ptInput;
                    Params[0].DataType := ftString;
                    Params[0].AsString := FRMVIEWS.StringGrid.cells[1, iI];
                    open;
                    szText := fieldbyname('text').asstring;
                    if BHtml then
                       TempMemo.Lines.Add('<PRE>');
                    while pos(chr(10), szText) <> 0 do
                        begin
                        szRow := copy(szText, 1, pos(chr(10), szText)-1);
                        //if BHtml then
                        //    TempMemo.Lines.Add(szRow+'<BR>')
                        //else
                            TempMemo.Lines.Add(szRow);
                        szText := copy(szText, pos(chr(10), szText)+1,length(szText));
                        end;

                    close;
                    if trim(szText) <> '' then
                        begin
                        //if BHtml then
                        //    TempMemo.Lines.Add(szText+'<BR>')  // viel viimenen rivi
                        //else
                        TempMemo.Lines.Add(szText);
                        end;
                    end;
                    if BHtml then
                       TempMemo.Lines.Add('</PRE>');
                if not BHtml then
                    TempMemo.Lines.Add('');

            end;
        end;
     if BHtml then
        TempMemoHeader.Lines.Add('</P>');
     if not BHtml then
         TempMemo.Lines.Add('')
     else TempMemo.Lines.Add('<HR>');
    inc(iPart);
end;

procedure TFRMMAIN.BuildProcs(BHtml: Boolean; var iPart: Integer);
var iI: Integer;
    previousUser, previousPassword, previousDatabase,
    szText, szRow: String;
    BFound, BHeader, BReadingParameters,
    BDescriptionFound, BReadinReturnValue: Boolean;
begin
    if BHtml then
        TempMemo.Lines.Add('<H3>');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('<A NAME="'+IntToStr(iPart)+'">');
    TempMemo.Lines.Add(IntToStr(iPart)+' Procedures and functions');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('</A>');
    if BHtml then
        TempMemo.Lines.Add('</H3>');

    if FRMOPTIONSDOCUMENT.FCBContent.Checked then
        begin
        if BHtml then
            TempMemoHeader.Lines.Add('<P><B><A HREF="#'+IntToStr(iPart)+'">');
        TempMemoHeader.Lines.Add(IntToStr(iPart)+' Procedures and functions');
        if BHtml then
            TempMemoHeader.Lines.Add('</A></B><BR>');
        end;

    if not BHtml then
        TempMemo.Lines.Add('');


    previousDatabase := '';
    previousUser := '';
    previousPassword := '';
    for iI:= 1 to FRMPROCS.StringGrid.RowCount - 1 do
        begin
        FRMPROGRESS.setInfoText('Building function or procedure: ' + chr(13) +
            chr(10) + FRMPROCS.StringGrid.cells[1, iI]);
        FRMPROGRESS.increasePosition(1);
        FRMPROGRESS.Refresh;

        if (previousDatabase <> FRMPROCS.StringGrid.cells[0,iI]) or
           (previousUser <> FRMPROCS.StringGrid.cells[2,iI]) or
           (previousPassword <> FRMPROCS.StringGrid.cells[3,iI]) then
            begin
            FRMLOGIN.Login(FRMPROCS.StringGrid.cells[0, iI],
                FRMPROCS.StringGrid.cells[2, iI],
                FRMPROCS.StringGrid.cells[3, iI]);
            previousDatabase := FRMPROCS.StringGrid.cells[0, iI];
            previousUser := FRMPROCS.StringGrid.cells[2, iI];
            previousPassword := FRMPROCS.StringGrid.cells[3, iI];
            end;

        szText := copy(FRMPROCS.FlatListBox2.items.strings[iI-1],
            pos('(', FRMPROCS.FlatListBox2.items.strings[iI-1]) + 1,
            pos(')', FRMPROCS.FlatListBox2.items.strings[iI-1]) -
            pos('(', FRMPROCS.FlatListBox2.items.strings[iI-1])-1) + ' ' +
            copy(FRMPROCS.FlatListBox2.items.strings[iI-1],
            pos('.', FRMPROCS.FlatListBox2.items.strings[iI-1]) + 1,
            pos('(', FRMPROCS.FlatListBox2.items.strings[iI-1]) -
            pos('.', FRMPROCS.FlatListBox2.items.strings[iI-1])-1);


        if BHtml then
            TempMemo.Lines.Add('<H4>');
        if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
            TempMemo.Lines.Add('<A NAME="'+IntToStr(iPart)+'.' + inttostr(iI)+'">');
        TempMemo.Lines.Add(IntToStr(iPart)+'.' + inttostr(iI) + ' ' + szText);
        if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
            TempMemo.Lines.Add('</A>');
        if BHtml then
            TempMemo.Lines.Add('</H4>');

        if FRMOPTIONSDOCUMENT.FCBContent.Checked then
            begin
            if BHtml then
                TempMemoHeader.Lines.Add(Oradoc_lib.HTMLTAB+'<I><A HREF="#'+IntToStr(iPart)+'.' + inttostr(iI)+'">');
            TempMemoHeader.Lines.Add(IntToStr(iPart)+'.' + inttostr(iI) + ' ' + szText);
            if BHtml then
                TempMemoHeader.Lines.Add('</A></I><BR>');
            end;

        if not BHtml then
            TempMemo.Lines.Add('');
                // kuvaus </fd> ja <fd/>
        with DMODD.OCIProctext do
            begin
            close;
            Params[0].ParamType := ptInput;
            Params[0].DataType := ftString;
            Params[0].AsString := trim(copy(FRMPROCS.FlatListBox2.items.strings[iI-1],
                pos('.', FRMPROCS.FlatListBox2.items.strings[iI-1]) + 1,
                pos('(', FRMPROCS.FlatListBox2.items.strings[iI-1]) -
                pos('.', FRMPROCS.FlatListBox2.items.strings[iI-1]) - 1));
            Params[1].ParamType := ptInput;
            Params[1].DataType := ftString;
            Params[1].AsString := trim(copy(FRMPROCS.FlatListBox2.items.strings[iI-1],
                pos('(', FRMPROCS.FlatListBox2.items.strings[iI-1]) + 1,
                pos(')', FRMPROCS.FlatListBox2.items.strings[iI-1]) -
                pos('(', FRMPROCS.FlatListBox2.items.strings[iI-1])-1));
            open;

            BFound := false;
            BHeader := false;
            BReadingParameters := false;
            BDescriptionFound := false;
            BReadinReturnValue := false;

            while not eof do
                begin
                szRow := fieldbyname('text').asstring;
                if pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdFunctionClose.Text), ansiuppercase(szRow)) <> 0 then
                    begin
                    if BHtml then TempMemo.Lines.Add('</P>');  //*
                        BFound := false;
                    end;
                if BFound then
                    begin
                    if BHtml then
                        begin
                        if (not BDescriptionFound) and (pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdDescription.Text),
                            Ansiuppercase(szRow)) <> 0) then
                            begin
                            BDescriptionFound := true;
                            TempMemo.Lines.Add('<H5>'+FRMOPTIONSPROCTAGS.FEdDescription.Text+'</H5><P>');  //*
                            szRow := copy(szRow, pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdDescription.Text),
                                Ansiuppercase(szRow)) +
                                length(FRMOPTIONSPROCTAGS.FEdDescription.Text) + 1, length(szRow)); //*
                            end;
                        if pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdParameters.Text),
                            Ansiuppercase(szRow)) <> 0 then
                            begin
                            BReadingParameters := true;
                            Oradoc_lib.AddToGrid(TempGrid, 'Name',1);
                            Oradoc_lib.AddToGrid(TempGrid, 'Type',2);
                            Oradoc_lib.AddToGrid(TempGrid, 'Description',3);
                            TempMemo.Lines.Add('</P><H5>'+FRMOPTIONSPROCTAGS.FEdParameters.Text+'</H5><P>'); //*
                            szRow := copy(szRow, pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdParameters.Text),
                                Ansiuppercase(szRow)) +
                                length(FRMOPTIONSPROCTAGS.FEdParameters.Text) + 1, length(szRow)); //*
                            end;
                        if pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdReturnValue.Text),
                            Ansiuppercase(szRow)) <> 0 then
                            begin
                            // talletetaan parametrit tiedostoon
                            if BReadingParameters then
                                begin
                                if BHtml then
                                    Oradoc_lib.FromGridToMemo(TempGrid, TempMemo,
                                        [200,100,300], true, true)
                                else
                                    Oradoc_lib.FromGridToMemo(TempGrid, TempMemo,
                                        [20,10,10], true, false);
                                end;
                            BReadingParameters := false;
                            if not BReadinReturnValue then
                                begin
                                System.delete(szRow, pos(':', szRow), 1);
                                TempMemo.Lines.Add('</P><H5>'+szRow+'</H5><P>');
                                BReadinReturnValue := true;
                                end
                            else
                                begin
                                TempMemo.Lines.Add(szRow);
                                end;
                            szRow := '';
                            end;

                        if trim(szRow) <> '' then
                            // jos impl niin luetaan parametreja
                            if BReadingParameters then
                                begin
                                // katsotaan lytyyk ':'
                                if not BHeader then
                                    if pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdColon.Text),
                                        Ansiuppercase(szRow)) <> 0 then
                                        begin
                                        Oradoc_lib.AddToGrid(TempGrid,
                                            copy(szRow, 1, pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdSpot.Text),
                                                Ansiuppercase(szRow))-1),1);
                                        Oradoc_lib.AddToGrid(TempGrid,
                                            copy(szRow, pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdSpot.Text),
                                                Ansiuppercase(szRow))+1,
                                            pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdColon.Text),
                                                Ansiuppercase(szRow))-
                                            pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdSpot.Text),
                                                Ansiuppercase(szRow))-1),2);
                                        szRow := copy(szRow, pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdColon.Text),
                                            Ansiuppercase(szRow))+1,length(szRow));
                                        BHeader := true;
                                        end;
                                if BHeader then
                                    begin
                                    // katsotaan lytyyk ';';
                                    if pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdSemiColon.Text),
                                        Ansiuppercase(szRow)) <> 0 then
                                        begin
                                        Oradoc_lib.AppendToGrid(TempGrid,
                                            copy(szRow,1,pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdSemiColon.Text),
                                                Ansiuppercase(szRow))-1),3);
                                        BHeader := false;
                                        end
                                    else
                                        Oradoc_lib.AppendToGrid(TempGrid, szRow, 3);
                                    end;
                                end
                            else
                                TempMemo.Lines.Add(szRow+'<BR>');
                        end
                    else
                        TempMemo.Lines.Add(szRow);
                    end;
                if pos(Ansiuppercase(FRMOPTIONSPROCTAGS.FEdFunctionOpen.Text),
                    Ansiuppercase(szRow)) <> 0 then
                    BFound := true;
                next;
                end;
                close;
        end;
    end;
    if BHtml then
        TempMemoHeader.Lines.Add('</P>');
    if not BHtml then
         TempMemo.Lines.Add('')
     else TempMemo.Lines.Add('<HR>');
    inc(iPart);
end;


procedure TFRMMAIN.BuildPackages(BHtml: Boolean; var iPart: Integer);
var iI, iJ: Integer;
    previousUser, previousPassword, previousDatabase,
    szRow: String;
    BFound, BHeader, BReadingParameters,
    BDescriptionFound, BReadinReturnValue,
    BFuncOrProcFound: Boolean;
begin
    if BHtml then
        TempMemo.Lines.Add('<H3>');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('<A NAME="'+IntToStr(iPart)+'">');
    TempMemo.Lines.Add(IntToStr(iPart)+' Packages');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('</A>');
    if BHtml then
        TempMemo.Lines.Add('</H3>');

    if FRMOPTIONSDOCUMENT.FCBContent.Checked then
        begin
        if BHtml then
            TempMemoHeader.Lines.Add('<P><B><A HREF="#'+IntToStr(iPart)+'">');
        TempMemoHeader.Lines.Add(IntToStr(iPart)+' Packages');
        if BHtml then
            TempMemoHeader.Lines.Add('</A></B><BR>');
        end;

    if not BHtml then
        TempMemo.Lines.Add('');

    previousDatabase := '';
    previousUser := '';
    previousPassword := '';
    for iI:= 1 to FRMPACKAGES.StringGrid.RowCount - 1 do
        begin
        FRMPROGRESS.setInfoText('Building package: ' + chr(13) +
            chr(10) + FRMPACKAGES.StringGrid.cells[1, iI]);
        FRMPROGRESS.increasePosition(1);
        FRMPROGRESS.Refresh;

        if (previousDatabase <> FRMPACKAGES.StringGrid.cells[0,iI]) or
           (previousUser <> FRMPACKAGES.StringGrid.cells[2,iI]) or
           (previousPassword <> FRMPACKAGES.StringGrid.cells[3,iI]) then
            begin
            FRMLOGIN.Login(FRMPACKAGES.StringGrid.cells[0, iI],
                FRMPACKAGES.StringGrid.cells[2, iI],
                FRMPACKAGES.StringGrid.cells[3, iI]);
            previousDatabase := FRMPACKAGES.StringGrid.cells[0, iI];
            previousUser := FRMPACKAGES.StringGrid.cells[2, iI];
            previousPassword := FRMPACKAGES.StringGrid.cells[3, iI];
            end;

        if BHtml then
            TempMemo.Lines.Add('<H4>');
        if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
            TempMemo.Lines.Add('<A NAME="'+IntToStr(iPart)+'.' + inttostr(iI)+'">');
        TempMemo.Lines.Add(IntToStr(iPart)+'.' + inttostr(iI) + ' ' + FRMPACKAGES.StringGrid.cells[1,iI]);
        if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
            TempMemo.Lines.Add('</A>');
        if BHtml then
            TempMemo.Lines.Add('</H4>');

        if FRMOPTIONSDOCUMENT.FCBContent.Checked then
            begin
            if BHtml then
                TempMemoHeader.Lines.Add(Oradoc_lib.HTMLTAB+'<I><A HREF="#'+IntToStr(iPart)+'.' + inttostr(iI)+'">');
            TempMemoHeader.Lines.Add(IntToStr(iPart)+'.' + inttostr(iI) + ' ' + FRMPACKAGES.StringGrid.cells[1,iI]);
            if BHtml then
                TempMemoHeader.Lines.Add('</A></I><BR>');
            end;

        if not BHtml then
            TempMemo.Lines.Add('');

        if BHtml then
            TempMemo.Lines.Add('<H5>');
        TempMemo.Lines.Add('Description');
        if BHtml then
            TempMemo.Lines.Add('</H5>');
        if not BHtml then
            TempMemo.Lines.Add('');
        if BHtml then
            TempMemo.Lines.Add('<P>');
        TempMemo.Lines.Add(FRMPACKAGES.StringGrid.cells[4, iI]);
        if BHtml then
            TempMemo.Lines.Add('</P>');
        if not BHtml then
            TempMemo.Lines.Add('');

        with DMODD.OCIPackageText do
            begin
            close;
            Params[0].ParamType := ptInput;
            Params[0].DataType := ftString;
            Params[0].AsString := FRMPACKAGES.StringGrid.cells[1, iI];
            open;

            BFound := false;
            BHeader := false;
            BReadingParameters := false;
            BDescriptionFound := false;
            BReadinReturnValue := false;
            BFuncOrProcFound := false;
            iJ := 1;
            first;
            while not eof do
                begin
                szRow := fieldbyname('text').asstring;
                if pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdPackageProcClose.Text),
                    ansiuppercase(szRow)) <> 0 then
                    begin
                    if BHtml then TempMemo.Lines.Add('</P>');  //*
                        BFound := false;
                    end;
                if BFound then
                    begin
                    if BHtml then
                        begin
                        if BFuncOrProcFound and (not BDescriptionFound) and (pos(ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdDescription2.Text), ansiuppercase(szRow)) <> 0) then
                            begin
                            BDescriptionFound := true;
                            TempMemo.Lines.Add('<H5>'+FRMOPTIONSPACKAGETAGS.FEdDescription2.Text+'</H5><P>');  //*
                            szRow := copy(szRow, pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdDescription2.Text),
                                Ansiuppercase(szRow)) +
                                length(FRMOPTIONSPACKAGETAGS.FEdDescription2.Text) + 1, length(szRow)); //*
                            end;

                        if (not BFuncOrProcFound) and (pos(ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdFunction.Text), ansiuppercase(szRow)) <> 0) or
                           (pos(ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdProcedure.Text), ansiuppercase(szRow)) <> 0) then
                            begin
                            if BHtml then
                                TempMemo.Lines.Add('<H4>'); //*
                            TempMemo.Lines.Add(IntToStr(iPart)+'.'+inttostr(iI)+'.'+inttostr(iJ) +' '+szRow);
                            if BHtml then
                                TempMemo.Lines.Add('</H4>'); //*
                            inc(iJ);
                            szRow := '';
                            BFuncOrProcFound := true;
                            end;

                        if pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdParameters.Text),
                            Ansiuppercase(szRow)) <> 0 then
                            begin
                            BReadingParameters := true;
                            Oradoc_lib.AddToGrid(TempGrid, 'Name',1);
                            Oradoc_lib.AddToGrid(TempGrid, 'Type',2);
                            Oradoc_lib.AddToGrid(TempGrid, 'Description',3);
                            TempMemo.Lines.Add('</P><H5>'+FRMOPTIONSPACKAGETAGS.FEdParameters.Text+'</H5><P>'); //*
                            szRow := copy(szRow, pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdParameters.Text),
                                Ansiuppercase(szRow)) +
                                        length(FRMOPTIONSPACKAGETAGS.FEdParameters.Text) + 1, length(szRow)); //*
                            end;
                        if pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdReturnValue.Text),
                            Ansiuppercase(szRow)) <> 0 then
                            begin
                            // talletetaan parametrit tiedostoon
                            if BReadingParameters then
                                begin
                                if BHtml then
                                    Oradoc_lib.FromGridToMemo(TempGrid, TempMemo,
                                        [200,100,300], true, true)
                                else
                                    Oradoc_lib.FromGridToMemo(TempGrid, TempMemo,
                                                [20,10,10], true, false);
                                end;

                                BReadingParameters := false;
                                if not BReadinReturnValue then
                                begin
                                System.delete(szRow, pos(':', szRow), 1);
                                TempMemo.Lines.Add('</P><H5>'+szRow+'</H5><P>');
                                BReadinReturnValue := true;
                                end
                                else
                                    begin
                                TempMemo.Lines.Add(szRow);
                                end;
                                szRow := '';
                            end;

                            if trim(szRow) <> '' then
                                // jos impl niin luetaan parametreja
                                if BReadingParameters then
                                    begin
                                    // katsotaan lytyyk ':'
                                    if not BHeader then
                                        if pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdColon.Text),
                                            Ansiuppercase(szRow)) <> 0 then
                                            begin
                                            Oradoc_lib.AddToGrid(TempGrid,
                                                copy(szRow, 1, pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdSpot.Text),
                                                    Ansiuppercase(szRow))-1), 1);
                                            Oradoc_lib.AddToGrid(TempGrid,
                                                copy(szRow, pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdSpot.Text),
                                                    Ansiuppercase(szRow))+1,
                                                pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdColon.Text),
                                                    Ansiuppercase(szRow))-
                                                pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdSpot.Text),
                                                    Ansiuppercase(szRow))-1), 2);
                                            szRow := copy(szRow, pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdColon.Text),
                                                Ansiuppercase(szRow))+1, length(szRow));
                                            BHeader := true;
                                            end;
                                    if BHeader then
                                        begin
                                        // katsotaan lytyyk ';';
                                        if pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdSemiColon.Text),
                                            Ansiuppercase(szRow)) <> 0 then
                                            begin
                                            Oradoc_lib.AppendToGrid(TempGrid,
                                                copy(szRow, 1, pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdSemiColon.Text),
                                                    Ansiuppercase(szRow))-1),3);
                                            BHeader := false;
                                            end
                                        else
                                            Oradoc_lib.AppendToGrid(TempGrid, szRow, 3);
                                        end;
                                    end
                                else
                                    TempMemo.Lines.Add(szRow+'<BR>');
                        end
                    else
                        TempMemo.Lines.Add(szRow);
                    end;
                if pos(Ansiuppercase(FRMOPTIONSPACKAGETAGS.FEdPackageProcOpen.Text),
                    Ansiuppercase(szRow)) <> 0 then
                    BFound := true;
                next;
                end;
                close;
            end;
        end;
    //end;
    if BHtml then
        TempMemoHeader.Lines.Add('</P>');
    if not BHtml then
         TempMemo.Lines.Add('')
     else TempMemo.Lines.Add('<HR>');
    inc(iPart);
end;

procedure TFRMMAIN.BuildSequences(BHtml: Boolean; var iPart: Integer);
var iI: Integer;
    previousUser, previousPassword, previousDatabase, szText: String;
begin
    if BHtml then
        TempMemo.Lines.Add('<H3>');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('<A NAME="'+IntToStr(iPart)+'">');
    TempMemo.Lines.Add(IntToStr(iPart)+' Sequences');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('</A>');
    if BHtml then
        TempMemo.Lines.Add('</H3>');

    if FRMOPTIONSDOCUMENT.FCBContent.Checked then
        begin
        if BHtml then
            TempMemoHeader.Lines.Add('<P><B><A HREF="#'+IntToStr(iPart)+'">');
        TempMemoHeader.Lines.Add(IntToStr(iPart)+' Sequences');
        if BHtml then
            TempMemoHeader.Lines.Add('</A></B></P>');
        end;

    if not BHtml then
        TempMemo.Lines.Add('');

    if trim(FRMSEQUENCES.FMDescription.text) <> '' then
        begin
        if BHtml then
            TempMemo.Lines.Add('<P>'); //*

        if BHtml then
            begin
            szText := FRMSEQUENCES.FMDescription.text;
            while pos(#13, szText) <> 0 do
                begin
                iI := pos(#13, szText);
                delete(szText, iI, 1);
                insert('</P><P>', szText, iI);
                end;
            TempMemo.Lines.Add(szText);
            end
        else
            TempMemo.Lines.Add(FRMSEQUENCES.FMDescription.text);

        if BHtml then
            TempMemo.Lines.Add('</P>'); //*
    end;
    if FRMSEQUENCES.StringGrid.rowcount - 1 > 0 then
        begin
        previousDatabase := '';
        previousUser := '';
        previousPassword := '';
        if not BHtml then
            TempMemo.Lines.Add('');
        Oradoc_lib.AddToGrid(TempGrid, 'Name', 1);
        Oradoc_lib.AddToGrid(TempGrid, 'Description', 2);
        for iI:= 1 to FRMSEQUENCES.StringGrid.RowCount - 1 do
            begin
            FRMPROGRESS.setInfoText('Building sequence: ' + chr(13) +
                chr(10) + FRMSEQUENCES.StringGrid.cells[1, iI]);
            FRMPROGRESS.increasePosition(1);
            FRMPROGRESS.Refresh;

            {if (previousDatabase <> FRMSEQUENCES.StringGrid.cells[0,iI]) or
               (previousUser <> FRMSEQUENCES.StringGrid.cells[2,iI]) or
               (previousPassword <> FRMSEQUENCES.StringGrid.cells[3,iI]) then
                begin
                FRMLOGIN.Login(FRMSEQUENCES.StringGrid.cells[0, iI],
                    FRMSEQUENCES.StringGrid.cells[2, iI],
                    FRMSEQUENCES.StringGrid.cells[3, iI]);
                previousDatabase := FRMSEQUENCES.StringGrid.cells[0, iI];
                previousUser := FRMSEQUENCES.StringGrid.cells[2, iI];
                previousPassword := FRMSEQUENCES.StringGrid.cells[3, iI];
                end;   }
            Oradoc_lib.AddToGrid(TempGrid, FRMSEQUENCES.StringGrid.cells[1, iI], 1);
            Oradoc_lib.AddToGrid(TempGrid, FRMSEQUENCES.StringGrid.cells[4, iI], 2);
            end;
        if BHtml then
            Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [300,0], true, true)
        else
            Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [30,30], true, false);
        end;
    if not BHtml then
    TempMemo.Lines.Add('')
     else TempMemo.Lines.Add('<HR>');

    inc(iPart);
end;

procedure TFRMMAIN.BuildRoles(BHtml: Boolean; var iPart: Integer);
var iI: Integer;
    previousUser, previousPassword, previousDatabase, szText: String;
begin
    if BHtml then
        TempMemo.Lines.Add('<H3>');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
         TempMemo.Lines.Add('<A NAME="'+IntToStr(iPart)+'">');
    TempMemo.Lines.Add(IntToStr(iPart)+' Roles and privileges');
    if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
        TempMemo.Lines.Add('</A>');
    if BHtml then
        TempMemo.Lines.Add('</H3>');

    if FRMOPTIONSDOCUMENT.FCBContent.Checked then
        begin
        if BHtml then
            TempMemoHeader.Lines.Add('<P><B><A HREF="#'+IntToStr(iPart)+'">');
        TempMemoHeader.Lines.Add(IntToStr(iPart)+' Roles and privileges');
        if BHtml then
            TempMemoHeader.Lines.Add('</A></B></P>');
        end;

    if not BHtml then
        TempMemo.Lines.Add('');

    if trim(FRMROLES.FMDescription.text) <> '' then
        begin
        if BHtml then
            TempMemo.Lines.Add('<P>'); //*

        if BHtml then
            begin
            szText := FRMROLES.FMDescription.text;
            while pos(#13, szText) <> 0 do
                begin
                iI := pos(#13, szText);
                delete(szText, iI, 1);
                insert('</P><P>', szText, iI);
                end;
            TempMemo.Lines.Add(szText);
            end
        else
            TempMemo.Lines.Add(FRMROLES.FMDescription.text);

        if BHtml then
            TempMemo.Lines.Add('</P>'); //*
    end;
    if FRMROLES.StringGrid.rowcount - 1 > 0 then
        begin
        previousDatabase := '';
        previousUser := '';
        previousPassword := '';

        if not BHtml then
            TempMemo.Lines.Add('');

        Oradoc_lib.AddToGrid(TempGrid, 'Name', 1);
        Oradoc_lib.AddToGrid(TempGrid, 'Description', 2);
        for iI := 1 to FRMROLES.StringGrid.RowCount - 1 do
            begin
            FRMPROGRESS.setInfoText('Building role: ' + chr(13) +
                chr(10) + FRMROLES.StringGrid.cells[1, iI]);
            FRMPROGRESS.increasePosition(1);
            FRMPROGRESS.Refresh;

            {if (previousDatabase <> FRMROLES.StringGrid.cells[0,iI]) or
               (previousUser <> FRMROLES.StringGrid.cells[2,iI]) or
               (previousPassword <> FRMROLES.StringGrid.cells[3,iI]) then
                begin
                FRMLOGIN.Login(FRMROLES.StringGrid.cells[0, iI],
                    FRMROLES.StringGrid.cells[2, iI],
                    FRMROLES.StringGrid.cells[3, iI]);
                previousDatabase := FRMROLES.StringGrid.cells[0, iI];
                previousUser := FRMROLES.StringGrid.cells[2, iI];
                previousPassword := FRMROLES.StringGrid.cells[3, iI];
                end;  }

            Oradoc_lib.AddToGrid(TempGrid, FRMROLES.StringGrid.cells[1, iI], 1);
            Oradoc_lib.AddToGrid(TempGrid, FRMROLES.StringGrid.cells[4, iI], 2);
            end;
            if BHtml then
                Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [300,0], true, true)
            else
                Oradoc_lib.FromGridToMemo(TempGrid, TempMemo, [30,30], true, false);
            if not BHtml then
                TempMemo.Lines.Add('')
            else TempMemo.Lines.Add('<HR>');
        end;
end;

procedure TFRMMAIN.MIBuildprojectClick(Sender: TObject);
var szFilename: String;
    BHtml: Boolean;
    iI, iPart, iMax: Integer;
    previousUser, previousPassword, previousDatabase: String;
begin
    SaveDialog.FileName := '';
    SaveDialog.Filter := Oradoc_lib.FILTERBUILD;
    SaveDialog.InitialDir := FRMOPTIONSDIRECTORIES.FEdProjectDirectory.text;
    SaveDialog.Title := Oradoc_lib.BUILDPROJECTTEXT;

    if SaveDialog.Execute then
    begin
        if Ansiuppercase(Statusbar.Panels.items[0].text) <> Ansiuppercase(Oradoc_lib.SBNOTCONNECTEDTEXT) then
            begin
            previousDatabase := DMODD.OCIDatabase.ServerName;
            previousUser := DMODD.OCIDatabase.UserName;
            previousPassword := DMODD.OCIDatabase.Password;
            end;
        FRMPROGRESS := TFRMPROGRESS.create(application);
        Oradoc_lib.setFormPosition(FRMPROGRESS, left, top, width, height);
        iMax := 1;
        if FRMOPTIONSDOCUMENT.FCBTables.Checked then
            iMax := iMax + FRMTABLES.FlatListBox2.Items.Count;
        if FRMOPTIONSDOCUMENT.FCBViews.Checked then
            iMax := iMax + FRMVIEWS.FlatListBox2.Items.Count;
        if FRMOPTIONSDOCUMENT.FCBProceduresAndFunctions.Checked then
            iMax := iMax + FRMPROCS.FlatListBox2.Items.Count;
        if FRMOPTIONSDOCUMENT.FCBPackages.Checked then
            iMax := iMax + FRMPACKAGES.FlatListBox2.Items.Count;
        if FRMOPTIONSDOCUMENT.FCBSequences.Checked then
            iMax := iMax + FRMSEQUENCES.FlatListBox2.Items.Count;
        if FRMOPTIONSDOCUMENT.FCBRolesAndPrivileges.Checked then
            iMax := iMax + FRMROLES.FlatListBox2.Items.Count;

        FRMPROGRESS.setMax(iMax);
        FRMTAB.FlatTabControl.ActiveTab := 0;
        Application.ProcessMessages;
        szFilename := SaveDialog.FileName;
        if SaveDialog.FilterIndex = 2 then
            begin
            if not (pos(Ansiuppercase(Oradoc_lib.TXTFILESUFFIX), Ansiuppercase(szFilename)) <> 0) then
                szFilename := szFilename + Oradoc_lib.TXTFILESUFFIX;
            BHtml := false;
            end
        else
            begin
            if not (pos(Ansiuppercase(Oradoc_lib.HTMLFILESUFFIX), Ansiuppercase(szFilename)) <> 0) then
                szFilename := szFilename + Oradoc_lib.HTMLFILESUFFIX;
            BHtml := true;
            end;
        TempMemo.Lines.Clear;
        TempMemoHeader.Lines.Clear;
        iPart := 1;

        BuildPageHeader(BHtml);
        if FRMOPTIONSDOCUMENT.FCBContent.Checked then
            BuildContent(BHtml);
        if FRMOPTIONSDOCUMENT.FCBProject.Checked then
            BuildProject(BHtml, iPart);
        if FRMOPTIONSDOCUMENT.FCBTables.Checked then
            BuildTables(BHtml, iPart);
        if FRMOPTIONSDOCUMENT.FCBViews.Checked then
            BuildViews(BHtml, iPart);
        if FRMOPTIONSDOCUMENT.FCBProceduresAndFunctions.Checked then
            BuildProcs(BHtml, iPart);
        if FRMOPTIONSDOCUMENT.FCBPackages.Checked then
            BuildPackages(BHtml, iPart);
        if FRMOPTIONSDOCUMENT.FCBSequences.Checked then
            BuildSequences(BHtml, iPart);
        if FRMOPTIONSDOCUMENT.FCBRolesAndPrivileges.Checked then
            BuildRoles(BHtml, iPart);

        if FRMOPTIONSDOCUMENT.FCBContent.Checked and BHtml then
            TempMemoHeader.Lines.add('<HR>');
            
       for iI := 0 to TempMemo.Lines.Count - 1 do
            TempMemoHeader.Lines.add(TempMemo.Lines.Strings[iI]);
       try
           try
           TempMemoHeader.Lines.SaveToFile(szFilename);
           finally
                if Ansiuppercase(Statusbar.Panels.items[0].text) = Ansiuppercase(Oradoc_lib.SBNOTCONNECTEDTEXT) then
                    DMODD.OCIDatabase.Close
                else
                    begin
                    DMODD.OCIDatabase.Close;
                    DMODD.OCIDatabase.ServerName := previousDatabase;
                    DMODD.OCIDatabase.UserName := previousUser;
                    DMODD.OCIDatabase.Password := previousPassword;
                    DMODD.OCIDatabase.Open;
                    setSBConnectText(DMODD.OCIDatabase.UserName +
                     Oradoc_lib.AT +
                     DMODD.OCIDatabase.ServerName);
                    end;

                FRMPROGRESS.setInfoText('Document is built.');
                FRMPROGRESS.setPosition(FRMPROGRESS.FProgressBar.Max);
                FRMPROGRESS.FBtnOk.Enabled := true;
                FRMPROGRESS.Refresh;
                FRMNEWVERSIONNUMBER.setVersionNumber(FRMPROJECT.FEdVersion.Text);
                FRMNEWVERSIONNUMBER.showmodal;
                FRMPROJECT.FEdVersion.Text := FRMNEWVERSIONNUMBER.getVersionNumber;
                setModifiedText(Oradoc_lib.SBMODIFIEDTEXT);
           end;
       except
           MessageDlg(Format(Oradoc_lib.DOCUMENTCREATEERROR, [szFileName]), mtError, [mbOK], 0);
       end;
    end;
end;

procedure TFRMMAIN.ToolButton8Click(Sender: TObject);
begin
    SaveFile(szProjectFilename);
end;

procedure TFRMMAIN.MISaveClick(Sender: TObject);
begin
    SaveFile(szProjectFilename);
end;

procedure TFRMMAIN.MISaveAsClick(Sender: TObject);
var szFilename: string;
begin
    SaveDialog.InitialDir := FRMOPTIONSDIRECTORIES.FEdProjectDirectory.text;
    SaveDialog.FileName := szProjectFilename;
    SaveDialog.Filter := Oradoc_lib.FILTERTEXTODD;
    SaveDialog.Title := Oradoc_lib.SAVEASTEXT;

    if SaveDialog.Execute then
        begin
        szFilename := SaveDialog.FileName;
        szProjectFilename := SaveDialog.filename;

        { add suffix if user did not }
        if not (pos(Ansiuppercase(Oradoc_lib.FILESUFFIX), ansiuppercase(szProjectFilename)) <> 0) then
            szProjectFilename := szProjectFilename + Oradoc_lib.FILESUFFIX;

        while pos(Oradoc_lib.BACKSLASH, szFilename) <> 0 do
            szFilename := copy(szFilename,pos(Oradoc_lib.BACKSLASH, szFilename)+1,length(szFilename)-pos(Oradoc_lib.BACKSLASH,szFilename));

        if pos(ansiuppercase(Oradoc_lib.FILESUFFIX), ansiuppercase(szFilename)) <> 0 then
            szFilename := copy(szFilename, 1, pos(ansiuppercase(Oradoc_lib.FILESUFFIX),
                ansiuppercase(szFilename))-1);

        FRMPROJECT.FEdName.Text := szFilename;

        if SaveFile(szProjectFilename) then
            begin
            SetAppState(asProjectOpened);
            SetMenuCaption(szProjectFilename);
            AddToHistoryFile(szProjectFilename);
            end
        else SetAppState(asProjectNotOpened);
    end;
end;

procedure TFRMMAIN.ToolButton10Click(Sender: TObject);
begin
    FRMLogin.setHistoryFile(FRMOPTIONSDIRECTORIES.FEdDBLogHistory.text);
    Oradoc_lib.setFormPosition(FRMLogin, left, top, width, height);
    if FRMLogin.ShowModal = mrOk then
    setSBConnectText(DMODD.OCIDatabase.UserName +
                     Oradoc_lib.AT +
                     DMODD.OCIDatabase.ServerName);
    FRMTAB.FlatTabControlTabChanged(self);
end;

procedure TFRMMAIN.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    SaveConfirm;
    SetAppState(asProjectNotOpened);
end;

procedure TFRMMAIN.Scramble(var szText: String; iSeed: Integer);
var szTemp, szResult: String;
    iI: Integer;
    cChar: Char;
begin
    szTemp := szText;
    while szTemp <> '' do
        begin
        cChar := szTemp[1];
        szTemp := copy(szTemp, 2, length(szTemp)-1);
        iI := length(inttostr(ord(cChar)-iSeed));
        szResult := szResult + inttostr(iI)+inttostr(ord(cChar)-iSeed);
        end;
    szText := szResult
end;

procedure TFRMMAIN.DeScramble(var szText: String; iSeed: Integer);
var szTemp, szResult, szNumber: String;
    iI, iJ: Integer;
    cChar: Char;
begin
    szTemp := szText;
    while szTemp <> '' do
        begin
        iJ := strtoint(copy(szTemp,1,1));
        szNumber := '';
        for iI := 2 to iJ + 1 do
            szNumber := szNumber + szTemp[iI];
        szTemp := copy(szTemp,iJ+2,length(szTemp));
        cChar :=  chr(strtoint(szNumber)+iSeed);
        szResult := szResult + cChar;
        end;
    szText := szResult
end;

procedure TFRMMAIN.Help;
begin
    HtmlHelp(GetDesktopWindow, PChar(mHHelp.ChmFile) , HH_DISPLAY_TOPIC,0);
//    MessageDlg('Version 1.0 will have a help file.', mtInformation, [mbOK], 0);
end;

procedure TFRMMAIN.MIContentsClick(Sender: TObject);
begin
    Help
end;

procedure TFRMMAIN.ToolButton11Click(Sender: TObject);
begin
    Help
end;

procedure TFRMMAIN.FormDestroy(Sender: TObject);
begin
    mHHelp.Free;
    HHCloseAll;
end;

end.
