unit Oradoc_tab;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TFlatTabControlUnit, StdCtrls, ExtCtrls;

type
  TFRMTAB = class(TForm)
    TabPanel: TPanel;
    FlatTabControl: TFlatTabControl;
    procedure FlatTabControlTabChanged(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FRMTAB: TFRMTAB;

implementation

uses Oradoc_project, Oradoc_packages, Oradoc_procs, Oradoc_roles,
     Oradoc_sequences, Oradoc_tables, Oradoc_views, Oradoc_lib,
     Oradoc_datamodule, Oradoc_login, Oradoc_options_directories,
     Oradoc_main;

{$R *.DFM}

procedure TFRMTAB.FlatTabControlTabChanged(Sender: TObject);
begin
    case FlatTabControl.ActiveTab of
    0: FRMPROJECT.PanelGeneral.BringToFront;
    1: FRMTABLES.PanelTables.BringToFront;
    2: FRMVIEWS.PanelViews.BringToFront;
    3: FRMPROCS.PanelProcs.BringToFront;
    4: FRMPACKAGES.PanelPackages.BringToFront;
    5: FRMSEQUENCES.PanelSequences.BringToFront;
    6: FRMROLES.PanelRoles.BringToFront;
    end;

    Application.ProcessMessages;

    if (FlatTabControl.ActiveTab > 0) and
       (not DMODD.OCIDatabase.Connected) then
    begin
        Oradoc_lib.setFormPosition(FRMLogin, FRMMain.left, FRMMain.top, FRMMain.width, FRMMain.height);
        FRMLogin.setHistoryFile(FRMOPTIONSDIRECTORIES.FEdDBLogHistory.text);
        if FRMLogin.ShowModal = mrOk then
            FRMMain.setSBConnectText(DMODD.OCIDatabase.UserName +
                                 Oradoc_lib.AT +
                                 DMODD.OCIDatabase.ServerName);
    end;

    case FlatTabControl.ActiveTab of
    1: begin
       if DMODD.OCIDatabase.Connected then
           Oradoc_lib.FillList(FRMTABLES.StringGrid, FRMTABLES.FlatListBox1,
               DMODD.OCITables, 'table_name');
       Oradoc_lib.setButtons(FRMTABLES.FlatListBox1, FRMTABLES.FlatListBox2,
           FRMTABLES.flatbutton1, FRMTABLES.flatbutton2,
           FRMTABLES.flatbutton3, FRMTABLES.flatbutton4);
       end;
    2: begin
       if DMODD.OCIDatabase.Connected then
           Oradoc_lib.FillList(FRMVIEWS.StringGrid, FRMVIEWS.FlatListBox1,
               DMODD.OCIViewNames, 'view_name');
       Oradoc_lib.setButtons(FRMVIEWS.FlatListBox1, FRMVIEWS.FlatListBox2,
           FRMVIEWS.flatbutton1, FRMVIEWS.flatbutton2,
           FRMVIEWS.flatbutton3, FRMVIEWS.flatbutton4);
       end;
    3: begin
       if DMODD.OCIDatabase.Connected then
           Oradoc_lib.FillList(FRMPROCS.StringGrid, FRMPROCS.FlatListBox1,
               DMODD.OCIProcedures, 'proc');
       Oradoc_lib.setButtons(FRMPROCS.FlatListBox1, FRMPROCS.FlatListBox2,
           FRMPROCS.flatbutton1, FRMPROCS.flatbutton2,
           FRMPROCS.flatbutton3, FRMPROCS.flatbutton4);
       end;
    4: begin
       if DMODD.OCIDatabase.Connected then
           Oradoc_lib.FillList(FRMPACKAGES.StringGrid, FRMPACKAGES.FlatListBox1,
               DMODD.OCIPackages, 'name');
       Oradoc_lib.setButtons(FRMPACKAGES.FlatListBox1, FRMPACKAGES.FlatListBox2,
           FRMPACKAGES.flatbutton1, FRMPACKAGES.flatbutton2,
           FRMPACKAGES.flatbutton3, FRMPACKAGES.flatbutton4);
       end;
    5: begin
       if DMODD.OCIDatabase.Connected then
           Oradoc_lib.FillList(FRMSEQUENCES.StringGrid, FRMSEQUENCES.FlatListBox1,
               DMODD.OCISequences, 'sequence_name');
       Oradoc_lib.setButtons(FRMSEQUENCES.FlatListBox1, FRMSEQUENCES.FlatListBox2,
           FRMSEQUENCES.flatbutton1, FRMSEQUENCES.flatbutton2,
           FRMSEQUENCES.flatbutton3, FRMSEQUENCES.flatbutton4);
       end;
    6: begin
       if DMODD.OCIDatabase.Connected then
           Oradoc_lib.FillList(FRMROLES.StringGrid, FRMROLES.FlatListBox1,
               DMODD.OCIRoles, 'grantee');
       Oradoc_lib.setButtons(FRMROLES.FlatListBox1, FRMROLES.FlatListBox2,
           FRMROLES.flatbutton1, FRMROLES.flatbutton2,
           FRMROLES.flatbutton3, FRMROLES.flatbutton4);
       end;
    end;
end;

procedure TFRMTAB.FormCreate(Sender: TObject);
begin
    TabPanel.height := Oradoc_lib.TAB_CLIENTPANEL_HEIGHT;
    TabPanel.width := Oradoc_lib.TAB_CLIENTPANEL_WIDTH;
end;

end.
